﻿AnchorTOT = CreateFrame("Frame","Move_TOT",UIParent) 
AnchorTOT:SetPoint("TOP", UIParent, "BOTTOM", 0, 330)
CreateAnchor(AnchorTOT, "Move tot", tDB["unitframes"]["width3"], tDB["unitframes"]["height1"])

AnchorExp = CreateFrame("Frame","Move_Exp",UIParent) 
AnchorExp:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 5)
CreateAnchor(AnchorExp, "Move exp and rep bar", 360, 5)

AnchorPlayer = CreateFrame("Frame","Move_Player",UIParent)
AnchorPlayer:SetPoint("TOPRIGHT", AnchorTOT, "TOPLEFT", -6, 0)
CreateAnchor(AnchorPlayer, "Move player", tDB["unitframes"]["width1"], tDB["unitframes"]["height1"])

AnchorTarget = CreateFrame("Frame","Move_Target",UIParent)
AnchorTarget:SetPoint("TOPLEFT", AnchorTOT, "TOPRIGHT", 6, 0)
CreateAnchor(AnchorTarget, "Move target", tDB["unitframes"]["width1"], tDB["unitframes"]["height1"])

AnchorFocus = CreateFrame("Frame","Move_Focus",UIParent) 
AnchorFocus:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -120, 370)
CreateAnchor(AnchorFocus, "Move focus", tDB["unitframes"]["width2"], tDB["unitframes"]["height1"])

AnchorFocusCast = CreateFrame("Frame","Move_FocusCast",UIParent)
AnchorFocusCast:SetPoint("TOPLEFT", AnchorFocus, "BOTTOMLEFT", 0, -14)
CreateAnchor(AnchorFocusCast, "Move focus castbar", tDB["unitframes"]["castfocusW"], tDB["unitframes"]["castfocusH"])

AnchorFocusTarget = CreateFrame("Frame","Move_FocusTarget",UIParent)
AnchorFocusTarget:SetPoint("RIGHT", AnchorFocus, "LEFT", -6, 0)
CreateAnchor(AnchorFocusTarget, "Move focus target", tDB["unitframes"]["width3"], tDB["unitframes"]["height1"])

AnchorPet = CreateFrame("Frame","Move_Pet",UIParent)
AnchorPet:SetPoint("TOPRIGHT", AnchorPlayer, "BOTTOMLEFT", -6, -6)
CreateAnchor(AnchorPet, "Move pet", tDB["unitframes"]["width2"], tDB["unitframes"]["height1"])

AnchorBoss = CreateFrame("Frame","Move_Boss",UIParent)
AnchorBoss:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -130, -210)
CreateAnchor(AnchorBoss, "Move boss", tDB["unitframes"]["width3"], tDB["unitframes"]["height1"])

AnchorPlayerCast = CreateFrame("Frame","Move_PlayerCast",UIParent)
AnchorPlayerCast:SetPoint("TOPRIGHT", AnchorPlayer, "BOTTOMRIGHT", 0, -14)
CreateAnchor(AnchorPlayerCast, "Move player castbar", tDB["unitframes"]["castplayerW"], tDB["unitframes"]["castplayerH"])

AnchorTargetCast = CreateFrame("Frame","Move_TargetCast",UIParent)
AnchorTargetCast:SetPoint("TOPLEFT", AnchorTarget, "BOTTOMLEFT", 0, -15)
CreateAnchor(AnchorTargetCast, "Move target castbar", tDB["unitframes"]["casttargetW"], tDB["unitframes"]["casttargetH"])

local name, addon = ...

local dropdown = CreateFrame('Frame', name .. 'DropDown', UIParent, 'UIDropDownMenuTemplate')

function addon:menu()
	dropdown:SetParent(self)
	return ToggleDropDownMenu(1, nil, dropdown, 'cursor', 0, 0)
end

----------------------------------------------
-- Menu --
-- Slightly altered version of:
-- FrameXML/CompactUnitFrame.lua:730:CompactUnitFrameDropDown_Initialize
----------------------------------------------
local init = function(self)
	local unit = self:GetParent().unit
	local menu, name, id

	if(not unit) then
		return
	end

	if(UnitIsUnit(unit, "player")) then
		menu = "SELF"
	elseif(UnitIsUnit(unit, "vehicle")) then
		-- NOTE: vehicle check must come before pet check for accuracy's sake because
		-- a vehicle may also be considered your pet
		menu = "VEHICLE"
	elseif(UnitIsUnit(unit, "pet")) then
		menu = "PET"
	elseif(UnitIsPlayer(unit)) then
		id = UnitInRaid(unit)
		if(id) then
			menu = "RAID_PLAYER"
			name = GetRaidRosterInfo(id)
		elseif(UnitInParty(unit)) then
			menu = "PARTY"
		else
			menu = "PLAYER"
		end
	else
		menu = "TARGET"
		name = RAID_TARGET_ICON
	end

	if(menu) then
		UnitPopup_ShowMenu(self, menu, unit, name, id)
	end
end

UIDropDownMenu_Initialize(dropdown, init, 'MENU')

local PortraitPostUpdate = function(self, unit)
	if tDB["unitframes"]["portoveray"] then self:SetAlpha(0.4) end
	--worgenmale fix by Hydra
	if self:GetModel() and self:GetModel().find and self:GetModel():find("worgenmale") then
		self:SetCamera(1)
	end
end

local portsize = 0
local expoffset = 0
local ufwidth1 = tDB["unitframes"]["width1"]

if tDB["unitframes"]["portraits"] and not tDB["unitframes"]["portoveray"] then
		portsize = tDB["unitframes"]["height1"]+12
		ufwidth1 = tDB["unitframes"]["width1"]-portsize
end

local SetFontString = function(parent, fontName, fontHeight, fontStyle)
	local CFS = parent:CreateFontString(nil, "OVERLAY")
	CFS:SetFont(fontName, fontHeight, fontStyle)
	CFS:SetJustifyH("LEFT")
	CFS:SetShadowColor(0, 0, 0)
	CFS:SetShadowOffset(1, -1)
	return CFS
end

local siValue = function(value)
	if value >= 10000000 then
		return string.format('%.1fm', value / 1000000)
	elseif value >= 1000000 then
		return string.format('%.2fm', value / 1000000)
	elseif value >= 100000 then
		return string.format('%.0fk', value / 1000)
	elseif value >= 10000 then
		return string.format('%.1fk', value / 1000)
	else
		return value
	end
end

----------------------------------------------
-- PostUpdateHealth - color health and add value
----------------------------------------------
local PostUpdateHealth = function(health, unit, min, max)
	if not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit) then
		health:SetValue(0)

		if not UnitIsConnected(unit) then
			health.value:SetText("|cffD7BEA5".."Offline".."|r")
		elseif UnitIsDead(unit) then
			health.value:SetText("|cffD7BEA5".."Dead".."|r")
		elseif UnitIsGhost(unit) then
			health.value:SetText("|cffD7BEA5".."Ghost".."|r")
		end

		if tDB["unitframes"]["ClassColor"] and (not tDB["unitframes"]["InvertColor"]) then
			local class = select(2, UnitClass(unit))
			local color = UnitIsPlayer(unit) and oUF.colors.class[class] or {0.84, 0.75, 0.65}
			health.bg:SetVertexColor(color[1]*tDB["unitframes"]["uicontrast"], color[2]*tDB["unitframes"]["uicontrast"], color[3]*tDB["unitframes"]["uicontrast"])
		elseif tDB["unitframes"]["ClassColor"] and tDB["unitframes"]["InvertColor"] then
			local class = select(2, UnitClass(unit))
			local color = UnitIsPlayer(unit) and oUF.colors.class[class] or {0.84, 0.75, 0.65}
			health.bg:SetVertexColor(color[1], color[2], color[3])
		else
			health.bg:SetVertexColor(unpack(tDB["cfgMedia"]["colorBR"]))
		end
	else
		if tDB["unitframes"]["ClassColor"] then
			local r, g, b = .84, .75, .65
			local t
			local reaction = UnitReaction(unit, "player")
			if(UnitIsPlayer(unit)) then
				local _, class = UnitClass(unit)
				t = oUF.colors.class[class]
			elseif reaction then
				t = oUF.colors.reaction[reaction]
			else
				r, g, b = .2, .9, .1
			end

			if(t) then
				r, g, b = t[1], t[2], t[3]
			end

			if tDB["unitframes"]["InvertColor"] then
				health:SetStatusBarColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
				health.bg:SetVertexColor(r, g, b)
			else
				health:SetStatusBarColor(r, g, b)
				health.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
			end
		else
			health:SetStatusBarColor(unpack(tDB["cfgMedia"]["colorBG"]))
			health.bg:SetVertexColor(unpack(tDB["cfgMedia"]["colorBR"]))
		end

		if min ~= max then
			r, g, b = oUF.ColorGradient(min/max, 0.69, 0.31, 0.31, 0.65, 0.63, 0.35, 0.33, 0.59, 0.33)
			if unit == "player" and health:GetAttribute("normalUnit") ~= "pet" then
				health.value:SetFormattedText("|cffAF5050%d|r |cffD7BEA5-|r |cff%02x%02x%02x%s%%|r", min, r * 255, g * 255, b * 255, math.floor(min /max*100+.5))
			elseif unit == "pet" then
				health.value:SetFormattedText("|cff%02x%02x%02x%s|r", r * 255, g * 255, b * 255, siValue(min))
			else
				health.value:SetFormattedText("|cffAF5050%s|r |cffD7BEA5-|r |cff%02x%02x%02x%s%%|r", siValue(min), r * 255, g * 255, b * 255, math.floor(min /max*100+.5))
			end
		else
			if unit ~= "player" and unit ~= "pet" then
				health.value:SetText("|cff559655"..siValue(max).."|r")
			else
				health.value:SetText("|cff559655"..max.."|r")
			end
		end
	end
end

function AltPowerBarPostUpdate(self, min, cur, max)
	local perc = math.floor((cur/max)*100)
	
	if perc < 35 then
		self:SetStatusBarColor(0, 1, 0)
	elseif perc < 70 then
		self:SetStatusBarColor(1, 1, 0)
	else
		self:SetStatusBarColor(1, 0, 0)
	end
end

----------------------------------------------
-- PreUpdatePower - color power
----------------------------------------------
local PreUpdatePower = function(power, unit)
	if tDB["unitframes"]["ClassColor"] then
		local r, g, b = 1, 1, 1
		local _, ptype = UnitPowerType(unit)
			if(oUF.colors.power[ptype]) then
				r, g, b = unpack(thundercolors.power[ptype])
			end

		if tDB["unitframes"]["InvertColor"] then
			power:SetStatusBarColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
			power.bg:SetVertexColor(r, g, b)
		else
			power:SetStatusBarColor(r, g, b)
			power.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
		end
	else
		local r, g, b = .84, .75, .65
		local t
		local reaction = UnitReaction(unit, "player")
		if(UnitIsPlayer(unit)) then
			local _, class = UnitClass(unit)
			t = oUF.colors.class[class]
		elseif reaction then
			t = oUF.colors.reaction[reaction]
		else
			r, g, b = .1, .8, .3
		end

		if(t) then
			r, g, b = t[1], t[2], t[3]
		end
		power:SetStatusBarColor(r, g, b)
		power.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
	end
end

----------------------------------------------
-- Post Update Power - add value text
----------------------------------------------
local PostUpdatePower = function(power, unit, min, max)

	local self = power:GetParent()

	local pType, pToken = UnitPowerType(unit)
	local color = thundercolors.power[pToken] or {0.84, 0.75, 0.65}

	if not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit) then
		power:SetValue(0)

		if tDB["unitframes"]["ClassColor"] and (not tDB["unitframes"]["InvertColor"]) then
			power.bg:SetVertexColor(color[1] * tDB["unitframes"]["uicontrast"], color[2] * tDB["unitframes"]["uicontrast"], color[3] * tDB["unitframes"]["uicontrast"])
		elseif tDB["unitframes"]["ClassColor"] and tDB["unitframes"]["InvertColor"] then
			power.bg:SetVertexColor(color[1], color[2], color[3])
		else
			local class = select(2, UnitClass(unit))
			local color = UnitIsPlayer(unit) and oUF.colors.class[class] or {0.84, 0.75, 0.65}
			power.bg:SetVertexColor(color[1] * tDB["unitframes"]["uicontrast"], color[2] * tDB["unitframes"]["uicontrast"], color[3] * tDB["unitframes"]["uicontrast"])
		end
	end

--	if not (unit == "player" or unit == "target" or unit == "focus") then return end
	
	if color then
		power.value:SetTextColor(color[1], color[2], color[3])
	end

	if min == 0 then
		power.value:SetText()
	elseif UnitIsDead(unit) or UnitIsGhost(unit) then
		power.value:SetText()
	else
		if min ~= max then
			if pType == 0 then
				if unit == "target" then
					power.value:SetText(siValue(min))
				elseif unit == "player" and power:GetAttribute("normalUnit") == "pet" or unit == "pet" then
					power.value:SetFormattedText("%%s%%", math.floor(min /max*100+.5))
				elseif unit == "player" then
					power.value:SetFormattedText("%s%% |cffD7BEA5-|r %d", math.floor(min /max*100+.5), min)
				else
					power.value:SetText(min)
				end
			else
				power.value:SetText(min)
			end
		else
			if unit == "player" then
				power.value:SetText(min)
			else
				power.value:SetText(siValue(min))
			end
		end
	end
end

----------------------------------------------
-- Aura Style
----------------------------------------------
local auraIcon = function(auras, button)
	local count = button.count
	count:ClearAllPoints()
	count:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["fontsize"], "OUTLINE")
	count:SetTextColor(1, 1, 1)
	count:SetPoint("BOTTOMRIGHT", 0, -1)

	auras.disableCooldown = true
	button.overlay:Hide()

	button.icon:SetTexCoord(.1, .9, .1, .9)
	button.icon:SetPoint("TOPLEFT", button, "TOPLEFT", 1, -1)
	button.icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -1, 1)

	local bd = CreateFrame("Frame", nil, button)
	bd:SetAllPoints()
	SetTemplate(bd, "bushadow")
	button.bd = bd

	local remaining = button:CreateFontString(nil, "OVERLAY")
	remaining:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["fontsize"], "OUTLINE")
	remaining:SetTextColor(1, 1, 1)
	remaining:SetPoint("CENTER", 0, 3)
	button.remaining = remaining
end


----------------------------------------------
-- AuraTimers
----------------------------------------------
local FormatTime = function(s)
	local day, hour, minute = 86400, 3600, 60
	if s >= day then
		return format("%dd", floor(s/day + 0.5)), s % day
	elseif s >= hour then
		return format("%dh", floor(s/hour + 0.5)), s % hour
	elseif s >= minute then
		return format("%dm", floor(s/minute + 0.5)), s % minute
	end
	return floor(s + 0.5), (s * 100 - floor(s * 100))/100
end

local CreateAuraTimer = function(self,elapsed)
	if self.timeLeft then
		self.elapsed = (self.elapsed or 0) + elapsed
		if self.elapsed >= 0.1 then
			if not self.first then
				self.timeLeft = self.timeLeft - self.elapsed
			else
				self.timeLeft = self.timeLeft - GetTime()
				self.first = false
			end
			if self.timeLeft > 0 then
				local atime = FormatTime(self.timeLeft)
				self.remaining:SetText(atime)
			else
				self.remaining:Hide()
				self:SetScript("OnUpdate", nil)
			end
			self.elapsed = 0
		end
	end
end

----------------------------------------------
-- PostUpdataIcon
----------------------------------------------
local PostUpdateIcon
do
	local playerUnits = {
		player = true,
		pet = true,
		vehicle = true,
	}

	PostUpdateIcon = function(icons, unit, icon, index, offset)
		local name, _, _, _, dtype, duration, expirationTime, unitCaster = UnitAura(unit, index, icon.filter)

	if icon.debuff then
	local color = DebuffTypeColor[dtype] or DebuffTypeColor.none
		icon.bd:SetBackdropBorderColor(color.r/2, color.g/2, color.b/2)
	else
		icon.bd:SetBackdropBorderColor(unpack(tDB["cfgMedia"]["colorBR"]))
	end

	if(icon.debuff and unit == 'target') then
		if(not UnitIsFriend('player', unit) and not playerUnits[icon.owner]) then
			icon.bd:SetBackdropBorderColor(0.1, 0.1, 0.1)
			icon.icon:SetDesaturated(true)
		else
			local color = DebuffTypeColor[dtype] or DebuffTypeColor.none
			icon.bd:SetBackdropBorderColor(color.r/2, color.g/2, color.b/2)
			icon.icon:SetDesaturated(false)
		end
	end

	if duration and duration > 0 then
		icon.remaining:Show()
	else
		icon.remaining:Hide()
	end

	icon.duration = duration
	icon.timeLeft = expirationTime
	icon.first = true
	icon:SetScript("OnUpdate", CreateAuraTimer)
	end
end

----------------------------------------------
-- CastBar function, credits Monolit
----------------------------------------------
CastOnCastSent = function(self, event, unit, spell, rank)
	if self.unit ~= unit or not self.Castbar.SafeZone then return end
	self.Castbar.SafeZone.sendTime = GetTime()
end

local CastPostCastStart = function(self, unit)
	self:SetAlpha(1.0)
	self.Spark:Show()
	self:SetStatusBarColor(unpack(tDB["unitframes"]["castcolor"]))
	if unit == "player" then
		local sf = self.SafeZone
		sf.timeDiff = GetTime() - sf.sendTime
		sf.timeDiff = sf.timeDiff > self.max and self.max or sf.timeDiff
		sf:SetWidth(self:GetWidth() * sf.timeDiff / self.max)
		sf:Show()		
	else
		if self.interrupt then
			self:SetStatusBarColor(unpack(tDB["unitframes"]["castcolor"]))
		else
			self:SetStatusBarColor(unpack(tDB["unitframes"]["castInterruptColor"]))
		end
	end
end

local CastOnCastbarUpdate = function(self, elapsed)
	local currentTime = GetTime()
	if self.casting or self.channeling then
		local parent = self:GetParent()
		local duration = self.casting and self.duration + elapsed or self.duration - elapsed
		if (self.casting and duration >= self.max) or (self.channeling and duration <= 0) then
			self.casting = nil
			self.channeling = nil
			return
		end
		if parent.unit == 'player' then
			if self.delay ~= 0 then
				self.Time:SetFormattedText('%.1f | |cffff0000%.1f|r', duration, self.casting and self.max + self.delay or self.max - self.delay)
			else
				self.Time:SetFormattedText('%.1f | %.1f', duration, self.max)
			end
		else
			self.Time:SetFormattedText('%.1f | %.1f', duration, self.casting and self.max + self.delay or self.max - self.delay)
		end
		self.duration = duration
		self:SetValue(duration)
		self.Spark:SetPoint('CENTER', self, 'LEFT', (duration / self.max) * self:GetWidth(), 0)
	else
		self.Spark:Hide()
		local alpha = self:GetAlpha() - 0.02
		if alpha > 0 then
			self:SetAlpha(alpha)
		else
			self.fadeOut = nil
			self:Hide()
		end
	end
end

local CastPostCastStop = function(self, unit, name, rank, castid)
	if not self.fadeOut then 
		self:SetStatusBarColor(unpack(tDB["unitframes"]["castCompleteColor"]))
		self.fadeOut = true
	end
	self:SetValue(self.max)
	self:Show()
end

local CastPostChannelStop = function(self, unit, name, rank)
	self.fadeOut = true
	self:SetValue(0)
	self:Show()
end

local CastPostCastFailed = function(self, event, unit, name, rank, castid)
	self:SetStatusBarColor(unpack(tDB["unitframes"]["castFailColor"]))
	self:SetValue(self.max)
	if not self.fadeOut then
		self.fadeOut = true
	end
	self:Show()
end

local castbar = function(self, unit)
	cb = CreateFrame("StatusBar", self:GetName().."_Castbar", self)
	cb:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"], "OVERLAY")
	cb:GetStatusBarTexture():SetHorizTile(false)

	cb.bg = cb:CreateTexture(nil, "BORDER")
	cb.bg:SetAllPoints()
	cb.bg:SetTexture(tDB["cfgMedia"]["textureBar"])
	cb.bg:SetVertexColor(unpack(tDB["cfgMedia"]["colorBG"]))

	cb.Time = cb:CreateFontString(nil, 'OVERLAY')
	cb.Time:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"])
	cb.Time:SetShadowOffset(1, -1)
	cb.Time:SetPoint("RIGHT", cb, -1, 1)

	cb.Text = cb:CreateFontString(nil, "OVERLAY")
	cb.Text:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"])
	cb.Text:SetShadowOffset(1, -1)
	cb.Text:SetPoint("LEFT", cb, 1, 1)
	cb.Text:SetPoint("RIGHT", cb.Time, "LEFT")
	cb.Text:SetJustifyH"LEFT"

	cb.Icon = cb:CreateTexture(nil, 'ARTWORK')
	cb.Icon:SetTexCoord(.1, .9, .1, .9)

	cb.bd = CreateFrame("Frame", nil, cb)
	cb.bd:SetPoint("TOPLEFT", cb, "TOPLEFT", -1, 1)
	cb.bd:SetPoint("BOTTOMRIGHT", cb, "BOTTOMRIGHT", 1, -1)
	SetTemplate(cb.bd, "bushadow")

	cb.iconbd = CreateFrame("Frame", nil, cb)
	cb.iconbd:SetPoint("TOPLEFT", cb.Icon, "TOPLEFT", -1, 1)
	cb.iconbd:SetPoint("BOTTOMRIGHT", cb.Icon, "BOTTOMRIGHT", 1, -1)
	SetTemplate(cb.iconbd, "bushadow")
	
	if unit == "player" then
		cb:SetPoint("TOPLEFT", AnchorPlayerCast, tDB["unitframes"]["castplayerH"]+2, -1)
		cb:SetPoint("BOTTOMRIGHT", AnchorPlayerCast, -1, 1)

		cb.Icon:SetHeight(tDB["unitframes"]["castplayerH"]-2)
		cb.Icon:SetWidth(tDB["unitframes"]["castplayerH"]-2)

		cb.Icon:SetPoint("RIGHT", cb, "LEFT", -3, 0)
		
		if tDB["unitframes"]["castbarslatency"] then
			cb.SafeZone = cb:CreateTexture(nil, "ARTWORK")
			cb.SafeZone:SetPoint('TOPRIGHT')
			cb.SafeZone:SetPoint('BOTTOMRIGHT')
			cb.SafeZone:SetTexture(tDB["cfgMedia"]["textureBar"])
			cb.SafeZone:SetVertexColor(0.69, 0.31, 0.31, 0.75)
			self:RegisterEvent("UNIT_SPELLCAST_SENT", CastOnCastSent)
		end
	elseif unit == "target" then
		cb:SetPoint("TOPLEFT", AnchorTargetCast, 1, -1)
		cb:SetPoint("BOTTOMRIGHT", AnchorTargetCast, -tDB["unitframes"]["casttargetH"]-2, 1)

		cb.Icon:SetHeight(tDB["unitframes"]["casttargetH"]-2)
		cb.Icon:SetWidth(tDB["unitframes"]["casttargetH"]-2)

		cb.Icon:SetPoint("LEFT", cb, "RIGHT", 3, 0)
	elseif unit == "focus" then
		cb:SetPoint("TOPLEFT", AnchorFocusCast, 1, -1)
		cb:SetPoint("BOTTOMRIGHT", AnchorFocusCast, -tDB["unitframes"]["castfocusH"]-2, 1)

		cb.Icon:SetHeight(tDB["unitframes"]["castfocusH"]-2)
		cb.Icon:SetWidth(tDB["unitframes"]["castfocusH"]-2)

		cb.Icon:SetPoint("LEFT", cb, "RIGHT", 3, 0)
	end
	
    spark = cb:CreateTexture(nil, "OVERLAY")
    spark:SetBlendMode("ADD")
    spark:SetAlpha(0.5)
    spark:SetHeight(cb:GetHeight()*2)
	
	cb.OnUpdate = CastOnCastbarUpdate
    cb.PostCastStart = CastPostCastStart
    cb.PostChannelStart = CastPostCastStart
	cb.PostCastStop = CastPostCastStop
	cb.PostChannelStop = CastPostChannelStop
	cb.PostCastFailed = CastPostCastFailed
	cb.PostCastInterrupted = CastPostCastFailed

	self.Castbar = cb
	self.Castbar.Spark = spark
end

----------------------------------------------
-- Reputation Bar Coloring
----------------------------------------------
local UpdateReputationColor = function(self, event, unit, bar)
	local name, id = GetWatchedFactionInfo()
	bar:SetStatusBarColor(FACTION_BAR_COLORS[id].r, FACTION_BAR_COLORS[id].g, FACTION_BAR_COLORS[id].b)
end

----------------------------------------------
-- Update Combo Points
----------------------------------------------
local UpdateCPoints = function(self, event, unit)
	if unit == PlayerFrame.unit and unit ~= self.CPoints.unit then
		self.CPoints.unit = unit
	end
end

----------------------------------------------
-- Zoomg UnitSpecific
----------------------------------------------
local UnitSpecific = {
	player = function(self)
		if tDB["unitframes"]["classbars"] and tDB["playerclass"] == "DEATHKNIGHT" then
			expoffset = 10
			local runeloadcolors = {
					[1] = {0.59, 0.31, 0.31},
					[2] = {0.59, 0.31, 0.31},
					[3] = {0.33, 0.51, 0.33},
					[4] = {0.33, 0.51, 0.33},
					[5] = {0.31, 0.45, 0.53},
					[6] = {0.31, 0.45, 0.53},
					}

			self.Runes = CreateFrame("Frame", nil, self)
			self.Runes:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.Runes:SetSize(ufwidth1-2, 5)

			for i = 1, 6 do
				self.Runes[i] = CreateFrame("StatusBar", "RuneBar_"..i, self.Runes)
				self.Runes[i]:SetSize((ufwidth1-7)/6, 5) --self.Runes:SetSize(ufwidth1-2, 5)
				self.Runes[i]:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
				self.Runes[i]:GetStatusBarTexture():SetHorizTile(false)
				self.Runes[i]:SetStatusBarColor(unpack(runeloadcolors[i]))

				if (i == 1) then
					self.Runes[i]:SetPoint("TOPLEFT", self.Runes, "TOPLEFT")
				else
					self.Runes[i]:SetPoint("LEFT", self.Runes[i - 1], "RIGHT", 1, 0)
				end
			end

			self.Runes.bg = CreateFrame("Frame", nil, self)
			self.Runes.bg:SetPoint("TOPLEFT", self.Runes, "TOPLEFT", -1, 1)
			self.Runes.bg:SetPoint("BOTTOMRIGHT", self.Runes, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.Runes.bg, "background")
		end
		if tDB["unitframes"]["classbars"] and tDB["playerclass"] == "SHAMAN" then
			expoffset = 10
			self.TotemBar = {}
			self.TotemBar.Destroy = true

			self.TBAR = CreateFrame("Frame", nil, self)
			self.TBAR:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.TBAR:SetSize(ufwidth1-2, 5)

			for i = 1, 4 do
				self.TotemBar[i] = CreateFrame("StatusBar", "TotemBar_"..i, self)
				self.TotemBar[i]:SetSize((ufwidth1-5)/4, 5)
				self.TotemBar[i]:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
				self.TotemBar[i]:GetStatusBarTexture():SetHorizTile(false)
				if i == 2 then
					self.TotemBar[i]:SetPoint("TOPLEFT", self.TBAR, "TOPLEFT")
				elseif i == 1 then
					self.TotemBar[i]:SetPoint("TOPLEFT", self.TBAR, "TOPLEFT", (ufwidth1-5)/4+1, 0)
				elseif i == 3 then
					self.TotemBar[i]:SetPoint("LEFT", self.TotemBar[1], "RIGHT", 1, 0)
				else
					self.TotemBar[i]:SetPoint("LEFT", self.TotemBar[3], "RIGHT", 1, 0)
				end
				self.TotemBar[i]:SetMinMaxValues(0, 1)
			end

			self.TBAR.bg = CreateFrame("Frame", nil, self)
			self.TBAR.bg:SetPoint("TOPLEFT", self.TBAR, "TOPLEFT", -1, 1)
			self.TBAR.bg:SetPoint("BOTTOMRIGHT", self.TBAR, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.TBAR.bg, "background")
		end
		if tDB["unitframes"]["classbars"] and tDB["playerclass"] == "PALADIN" then
			expoffset = 10
			self.HolyPower = CreateFrame("Frame", nil, self)
			self.HolyPower:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.HolyPower:SetSize(ufwidth1-2, 5)
			self.HolyPower.anchor = 'BOTTOM'
			self.HolyPower.growth = 'RIGHT'

			for i = 1, 3 do
				self.HolyPower[i] = CreateFrame("StatusBar", nil, self.HolyPower)
				self.HolyPower[i]:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
				self.HolyPower[i]:SetSize((ufwidth1-4)/3, 5)
				self.HolyPower[i]:SetStatusBarColor(1,.95,.33)

				if (i == 1) then
					self.HolyPower[i]:SetPoint("TOPLEFT", self.HolyPower, "TOPLEFT")
				else
					self.HolyPower[i]:SetPoint("LEFT", self.HolyPower[i - 1], "RIGHT", 1, 0)
				end
			end

			self.HolyPower.bg = CreateFrame("Frame", nil, self)
			self.HolyPower.bg:SetPoint("TOPLEFT", self.HolyPower, "TOPLEFT", -1, 1)
			self.HolyPower.bg:SetPoint("BOTTOMRIGHT", self.HolyPower, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.HolyPower.bg, "background")
		end
		if tDB["unitframes"]["classbars"] and tDB["playerclass"] == "WARLOCK" then
			expoffset = 10
			self.SoulShards = CreateFrame("Frame", nil, self)
			self.SoulShards:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.SoulShards:SetSize(ufwidth1-2, 5)
			self.SoulShards.anchor = 'BOTTOM'
			self.SoulShards.growth = 'RIGHT'

			for i = 1, 3 do
				self.SoulShards[i] = CreateFrame("StatusBar", nil, self.SoulShards)
				self.SoulShards[i]:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
				self.SoulShards[i]:SetSize((ufwidth1-4)/3, 5)
				self.SoulShards[i]:SetStatusBarColor(1,.95,.33)

				if (i == 1) then
					self.SoulShards[i]:SetPoint("TOPLEFT", self.SoulShards, "TOPLEFT")
				else
					self.SoulShards[i]:SetPoint("LEFT", self.SoulShards[i - 1], "RIGHT", 1, 0)
				end
			end

			self.SoulShards.bg = CreateFrame("Frame", nil, self)
			self.SoulShards.bg:SetPoint("TOPLEFT", self.SoulShards, "TOPLEFT", -1, 1)
			self.SoulShards.bg:SetPoint("BOTTOMRIGHT", self.SoulShards, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.SoulShards.bg, "background")
		end
		if tDB["unitframes"]["classbars"] and tDB["playerclass"] == "DRUID" then
			expoffset = 10
			self.EclipseBar = CreateFrame('Frame', nil, self)
			self.EclipseBar:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.EclipseBar:SetSize(ufwidth1-2, 5)

			self.EclipseBar.bd = CreateFrame("Frame", nil, self.EclipseBar)
			self.EclipseBar.bd:SetPoint("TOPLEFT", self.EclipseBar, "TOPLEFT", -1, 1)
			self.EclipseBar.bd:SetPoint("BOTTOMRIGHT", self.EclipseBar, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.EclipseBar.bd, "background")

			local lunarBar = CreateFrame("StatusBar", nil, self.EclipseBar)
			lunarBar:SetPoint("LEFT", self.EclipseBar, "LEFT", 0, 0)
			lunarBar:SetSize(self.EclipseBar:GetWidth(), self.EclipseBar:GetHeight())
			lunarBar:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
			lunarBar:SetStatusBarColor(0.34, 0.1, 0.86)
			self.EclipseBar.LunarBar = lunarBar

			local solarBar = CreateFrame("StatusBar", nil, self.EclipseBar)
			solarBar:SetPoint("LEFT", lunarBar:GetStatusBarTexture(), "RIGHT", 0, 0)
			solarBar:SetSize(self.EclipseBar:GetWidth(), self.EclipseBar:GetHeight())
			solarBar:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
			solarBar:SetStatusBarColor(0.95, 0.73, 0.15)
			self.EclipseBar.SolarBar = solarBar

			local eclipseBarText = solarBar:CreateFontString(nil, "OVERLAY")
			eclipseBarText:SetPoint("CENTER", self.EclipseBar, "CENTER")
			eclipseBarText:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"]-1, "OUTLINE")
			self:Tag(eclipseBarText, '[pereclipse]%')
        end
		if UnitLevel("player") < MAX_PLAYER_LEVEL then
			self.Experience = CreateFrame("StatusBar", nil, self)
			self.Experience:SetAllPoints(AnchorExp)
			self.Experience:SetFrameLevel(20)
			self.Experience:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
			self.Experience:SetStatusBarColor(0.1, 0.7, 1)
			self.Experience.Tooltip = true

			self.Experience.Rested = CreateFrame('StatusBar', nil, self.Experience)
			self.Experience.Rested:SetAllPoints()
			self.Experience.Rested:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
			self.Experience.Rested:SetStatusBarColor(0, 0.2, 0.5)
			
			self.Experience.Rested.bg = CreateFrame("Frame", nil, self.Experience.Rested)
			self.Experience.Rested.bg:SetPoint("TOPLEFT", self.Experience.Rested, "TOPLEFT", -1, 1)
			self.Experience.Rested.bg:SetPoint("BOTTOMRIGHT", self.Experience.Rested, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.Experience.Rested.bg, "background")
		end
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			self.Reputation = CreateFrame('StatusBar', nil, self) --self.Power
			self.Reputation:SetAllPoints(AnchorExp)
			self.Reputation:SetFrameLevel(20)
			self.Reputation:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
			self.Reputation.PostUpdate = UpdateReputationColor
			self.Reputation.Tooltip = true
	
			self.Reputation.bg = CreateFrame("Frame", nil, self.Reputation)
			self.Reputation.bg:SetPoint("TOPLEFT", self.Reputation, "TOPLEFT", -1, 1)
			self.Reputation.bg:SetPoint("BOTTOMRIGHT", self.Reputation, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.Reputation.bg, "background")
		end
		if tDB["unitframes"]["auras"] and tDB["unitframes"]["debuffs"] then
			self.Debuffs = CreateFrame("Frame", nil, self)
			self.Debuffs:SetHeight(100)
			self.Debuffs:SetWidth(ufwidth1+portsize)
			self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -portsize, 3)
			self.Debuffs.initialAnchor = "BOTTOMLEFT"
			self.Debuffs["growth-y"] = "UP"
			self.Debuffs.spacing = 3
			self.Debuffs.size = tDB["unitframes"]["aurasize"]
			self.Debuffs.num = tDB["unitframes"]["auralimit"]*2
			self.Debuffs.PostCreateIcon = auraIcon
			self.Debuffs.PostUpdateIcon = PostUpdateIcon
		end
		if tDB["unitframes"]["castbars"] then
			castbar(self, "player") -- create castbar

			PetCastingBarFrame:UnregisterAllEvents()
			PetCastingBarFrame.Show = function() end
			PetCastingBarFrame:Hide()
		end
		self.AltPowerBar = CreateFrame("StatusBar", nil, self)
		self.AltPowerBar:SetSize(ufwidth1-2, 5)
		self.AltPowerBar:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3-expoffset)		
		self.AltPowerBar:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
		self.AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
		self.AltPowerBar:SetFrameStrata("HIGH")

		self.AltPowerBar.bg = CreateFrame("Frame", nil, self.AltPowerBar)
		self.AltPowerBar.bg:SetPoint("TOPLEFT", self.AltPowerBar, -1, 1)
		self.AltPowerBar.bg:SetPoint("BOTTOMRIGHT", self.AltPowerBar, 1, -1)
		SetTemplate(self.AltPowerBar.bg, "background")

		self.AltPowerBar.text = SetFontString(self.AltPowerBar, tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"]-1, "OUTLINE")
		self.AltPowerBar.text:SetPoint("CENTER")
		self:Tag(self.AltPowerBar.text, '[thunder:altpower]')

		self.AltPowerBar.PostUpdate = AltPowerBarPostUpdate
	end,

	target = function(self)
			local cpcolors = {
					[1] = {1, 0.11, 0.11},
					[2] = {1, 0.11, 0.11},
					[3] = {1, 1, 0.33},
					[4] = {1, 1, 0.33},
					[5] = {0.33, 1, 0.33},
					}

			self.CPB = CreateFrame("Frame", nil, self)
			self.CPB:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)
			self.CPB:SetSize(ufwidth1-2, 5)

			self.CPoints = {}
			self.CPoints.unit = PlayerFrame.unit

			for i = 1, 5 do
				self.CPoints[i] = CreateFrame("StatusBar", "CpBar"..i, self)
				self.CPoints[i]:SetSize((ufwidth1-6)/5,5)
				self.CPoints[i]:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
				self.CPoints[i]:GetStatusBarTexture():SetHorizTile(false)
				self.CPoints[i]:SetStatusBarColor(unpack(cpcolors[i]))

				if (i == 1) then
					self.CPoints[i]:SetPoint("TOPLEFT", self.CPB, "TOPLEFT")
				else
					self.CPoints[i]:SetPoint("LEFT", self.CPoints[i - 1], "RIGHT", 1, 0)
				end
			end

			self.CPB.bg = CreateFrame("Frame", nil, self.CPoints[1])
			self.CPB.bg:SetPoint("TOPLEFT", self.CPB, "TOPLEFT", -1, 1)
			self.CPB.bg:SetPoint("BOTTOMRIGHT", self.CPB, "BOTTOMRIGHT", 1, -1)
			SetTemplate(self.CPB.bg, "background")

			self:RegisterEvent("UNIT_COMBO_POINTS", UpdateCPoints)

	-- mouseover focus script by Munglunch
		if tDB["unitframes"]["focuspocus"] then
			local focuspoint = CreateFrame("BUTTON", "mouseFocus", self.Health, "SecureActionButtonTemplate")
			focuspoint:EnableMouse(true)
			focuspoint:RegisterForClicks("AnyUp")
			focuspoint:SetAttribute("type", "macro")
			focuspoint:SetAttribute("macrotext", "/focus")
			focuspoint:SetHeight(12)
			focuspoint:SetWidth(12)
			focuspoint:SetPoint("BOTTOMRIGHT", self.Health, 0, 0)
			focuspoint:SetFrameLevel(20)

			local focuspointtext = focuspoint:CreateTexture(nil, "ARTWORK")
			focuspointtext:SetTexture(tDB["cfgMedia"]["textureCP"])
			focuspointtext:SetParent(focuspoint)
			focuspointtext:SetAllPoints(focuspoint)
			focuspointtext:SetVertexColor(0.8, 0.8, 0.3, 1)
			focuspointtext:SetAlpha(0)

			focuspoint:SetScript("OnLeave", function() focuspointtext:SetAlpha(0) end)
			focuspoint:SetScript("OnEnter", function(self) focuspointtext:SetAlpha(1) end)
		end
		if tDB["unitframes"]["auras"] and tDB["unitframes"]["allinone"] then
			self.Auras = CreateFrame("Frame", nil, self)
			self.Auras:SetHeight(200)
			self.Auras:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 0, 3)
			self.Auras:SetWidth(ufwidth1+portsize)
			self.Auras['growth-y'] = 'UP'
			self.Auras.initialAnchor = 'BOTTOMLEFT'
			self.Auras['growth-x'] = 'RIGHT'
			self.Auras.spacing = 3
			self.Auras.size = tDB["unitframes"]["aurasize"]
			self.Auras.gap = true
			self.Auras.numBuffs = tDB["unitframes"]["auralimit"]
			self.Auras.numDebuffs = tDB["unitframes"]["auralimit"]*2
			self.Auras.onlyShowPlayer = tDB["unitframes"]["onlyplayerdebuffs"]

			self.Auras.PostCreateIcon = auraIcon
			self.Auras.PostUpdateIcon = PostUpdateIcon
		elseif tDB["unitframes"]["auras"] and tDB["unitframes"]["allinone"] ~= true then
			self.Buffs = CreateFrame("Frame", nil, self)
			self.Buffs:SetHeight(10)
			self.Buffs:SetWidth(ufwidth1)
			self.Buffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 3)
			self.Buffs.initialAnchor = "BOTTOMLEFT"
			self.Buffs['growth-y'] = 'UP'
			self.Buffs.spacing = 3
			self.Buffs.size = tDB["unitframes"]["aurasize"]
			self.Buffs.num = tDB["unitframes"]["auralimit"]
			self.Buffs['growth-x'] = 'RIGHT'
			self.Buffs.PostCreateIcon = auraIcon
			self.Buffs.PostUpdateIcon = PostUpdateIcon

			self.Debuffs = CreateFrame("Frame", nil, self)
			self.Debuffs:SetHeight(100)
			self.Debuffs:SetWidth(ufwidth1)
			self.Debuffs:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, tDB["unitframes"]["aurasize"]+5)
			self.Debuffs.initialAnchor = "BOTTOMRIGHT"
			self.Debuffs['growth-y'] = 'UP'
			self.Debuffs.spacing = 3
			self.Debuffs.size = tDB["unitframes"]["aurasize"]
			self.Debuffs.num = tDB["unitframes"]["auralimit"]*2
			self.Debuffs['growth-x'] = 'LEFT'
			self.Debuffs.onlyShowPlayer = tDB["unitframes"]["onlyplayerdebuffs"]
			self.Debuffs.PostCreateIcon = auraIcon
			self.Debuffs.PostUpdateIcon = PostUpdateIcon
		end
		if tDB["unitframes"]["castbars"] then
			castbar(self, "target") -- create castbar
		end		
	end,
	
	focus = function(self)
		if tDB["unitframes"]["auras"] then
			local focuspoint2 = CreateFrame("BUTTON", "mouseFocus", self.Health, "SecureActionButtonTemplate")
			focuspoint2:EnableMouse(true)
			focuspoint2:RegisterForClicks("AnyUp")
			focuspoint2:SetAttribute("type", "macro")
			focuspoint2:SetAttribute("macrotext", "/clearfocus")
			focuspoint2:SetHeight(12)
			focuspoint2:SetWidth(12)
			focuspoint2:SetPoint("BOTTOMRIGHT", self.Health, 0, 0)
			focuspoint2:SetFrameLevel(20)

			local focuspoint2text = focuspoint2:CreateTexture(nil, "ARTWORK")
			focuspoint2text:SetTexture(tDB["cfgMedia"]["textureCP"])
			focuspoint2text:SetParent(focuspoint2)
			focuspoint2text:SetAllPoints(focuspoint2)
			focuspoint2text:SetVertexColor(0.8, 0.8, 0.3, 1)
			focuspoint2text:SetAlpha(0)

			focuspoint2:SetScript("OnLeave", function() focuspoint2text:SetAlpha(0) end)
			focuspoint2:SetScript("OnEnter", function(self) focuspoint2text:SetAlpha(1) end)
		end
		if tDB["unitframes"]["auras"] and tDB["unitframes"]["focusdebuffs"] then
			self.Debuffs = CreateFrame("Frame", nil, self)
			self.Debuffs:SetHeight(10)
			self.Debuffs:SetWidth(tDB["unitframes"]["width2"])
			self.Debuffs:SetPoint("TOPLEFT", self, "TOPRIGHT", 3, 0)
			self.Debuffs.initialAnchor = "TOPLEFT"
			self.Debuffs.spacing = 3
			self.Debuffs.size = tDB["unitframes"]["aurasize"]
			self.Debuffs.num = 4
			self.Debuffs['growth-y'] = 'DOWN'
			self.Debuffs.onlyShowPlayer = tDB["unitframes"]["onlyplayerdebuffs"]
			self.Debuffs.PostCreateIcon = auraIcon
			self.Debuffs.PostUpdateIcon = PostUpdateIcon
		end
		if tDB["unitframes"]["castbars"] then
			castbar(self, "focus")
		end	
	end,
	
	targettarget = function(self)
		if tDB["unitframes"]["auras"] and tDB["unitframes"]["totdebuffs"] then
			self.Debuffs = CreateFrame("Frame", nil, self)
			self.Debuffs:SetHeight(10)
			self.Debuffs:SetWidth(tDB["unitframes"]["width3"])
			self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 3)
			self.Debuffs.initialAnchor = "BOTTOMLEFT"
			self.Debuffs["growth-y"] = "UP"
			self.Debuffs.spacing = 3
			self.Debuffs.size = tDB["unitframes"]["aurasize"]
			self.Debuffs.num = 4
			self.Debuffs.PostCreateIcon = auraIcon
			self.Debuffs.PostUpdateIcon = PostUpdateIcon
		end
	end,
	
	boss = function(self)
		if tDB["unitframes"]["auras"] and tDB["unitframes"]["bossbuffs"] then
			self.Buffs = CreateFrame("Frame", nil, self)
			self.Buffs:SetHeight(10)
			self.Buffs:SetWidth(tDB["unitframes"]["width2"])
			self.Buffs:SetPoint("TOPLEFT", self, "TOPRIGHT", 3, 0)
			self.Buffs.initialAnchor = "TOPLEFT"
			self.Buffs.spacing = 3
			self.Buffs.size = tDB["unitframes"]["aurasize"]
			self.Buffs.num = 4
			self.Buffs['growth-y'] = 'DOWN'
			self.Buffs.PostCreateIcon = auraIcon
			self.Buffs.PostUpdateIcon = PostUpdateIcon
		end
		self.AltPowerBar = CreateFrame("StatusBar", nil, self)
		self.AltPowerBar:SetSize(tDB["unitframes"]["width3"]-2, 5)
		self.AltPowerBar:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, -3)		
		self.AltPowerBar:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
		self.AltPowerBar:GetStatusBarTexture():SetHorizTile(false)
		self.AltPowerBar:SetFrameStrata("HIGH")

		self.AltPowerBar.bg = CreateFrame("Frame", nil, self.AltPowerBar)
		self.AltPowerBar.bg:SetPoint("TOPLEFT", self.AltPowerBar, -1, 1)
		self.AltPowerBar.bg:SetPoint("BOTTOMRIGHT", self.AltPowerBar, 1, -1)
		SetTemplate(self.AltPowerBar.bg, "background")

		self.AltPowerBar.text = SetFontString(self.AltPowerBar, tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"]-1, "OUTLINE")
		self.AltPowerBar.text:SetPoint("CENTER")
		self:Tag(self.AltPowerBar.text, '[thunder:altpower]')

		self.AltPowerBar.PostUpdate = AltPowerBarPostUpdate
	end,
}

local thunderstyle = function(self, unit)
	self.menu = addon.menu

	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)

	self:RegisterForClicks"AnyUp"
	
	self.bg = CreateFrame("Frame", nil, self)
	self.bg:SetAllPoints()
	SetTemplate(self.bg, "background")
	
----------------------------------------------
-- HealthBar
----------------------------------------------
	self.Health = CreateFrame("StatusBar", self:GetName().."_Health", self)
	self.Health:SetHeight(tDB["unitframes"]["height1"]-24)
	self.Health:SetPoint("TOPLEFT", 1, -1)
	self.Health:SetPoint("TOPRIGHT", -1, -1)
	self.Health:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
	self.Health:GetStatusBarTexture():SetHorizTile(false)

	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints()
	self.Health.bg:SetTexture(tDB["cfgMedia"]["textureBar"])

	self.Health.colorTapping = true
	self.Health.frequentUpdates = true
	self.Health.Smooth = true

	self.Health.PostUpdate = PostUpdateHealth

----------------------------------------------
-- Portrait
----------------------------------------------
if tDB["unitframes"]["portraits"] and (unit == "player" or unit == "target") then
	self.Portrait = CreateFrame("PlayerModel", nil, self)
	if tDB["unitframes"]["portoveray"] then
		self.Portrait:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 0, 0)
		self.Portrait:SetPoint("BOTTOMRIGHT", self.Health, "BOTTOMRIGHT", 0, 0)
		self.Portrait.PostUpdate = PortraitPostUpdate
	else
		if unit == "player" then
			self.Portrait:SetPoint("TOPRIGHT", self.Health, "TOPLEFT", -5, 0)
		else
			self.Portrait:SetPoint("TOPLEFT", self.Health, "TOPRIGHT", 5, 0)
		end
		self.Portrait:SetSize(portsize-5,portsize-5)
		self.Portrait.PostUpdate = PortraitPostUpdate
		
		self.Portrait.bg = CreateFrame("Frame", nil, self.Portrait)
		self.Portrait.bg:SetPoint("TOPLEFT", self.Portrait, "TOPLEFT", -1, 1)
		self.Portrait.bg:SetPoint("BOTTOMRIGHT", self.Portrait, "BOTTOMRIGHT", 1, -1)
		SetTemplate(self.Portrait.bg, "background")
	end
end
	
----------------------------------------------
-- PowerBar
----------------------------------------------
	self.Power = CreateFrame("StatusBar", self:GetName().."_Power", self)
	self.Power:SetHeight(5)
	self.Power:SetPoint("TOPLEFT", self.Health, "BOTTOMLEFT", 0, -1)
	self.Power:SetPoint("TOPRIGHT", self.Health, "BOTTOMRIGHT", 0, -1)
	self.Power:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
	self.Power:GetStatusBarTexture():SetHorizTile(false)

	self.Power.bg = self.Power:CreateTexture(nil, "BORDER")
	self.Power.bg:SetAllPoints()
	self.Power.bg:SetTexture(tDB["cfgMedia"]["textureBar"])

	self.Power.frequentUpdates = true
	self.Power.Smooth = true

	self.Power.PreUpdate = PreUpdatePower
	self.Power.PostUpdate = PostUpdatePower

	self.Powerpanel = CreateFrame("Frame", nil, self)
	self.Powerpanel:SetPoint("TOPLEFT", self.Power, -1, 1)
	self.Powerpanel:SetPoint("BOTTOMRIGHT", self.Power, 1, -1)
	SetTemplate(self.Powerpanel)

----------------------------------------------
-- TextInfo
----------------------------------------------

	self.Health.value = SetFontString(self, tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"])
	self.Health.value:SetPoint("BOTTOMRIGHT", -2, 3)

	self.Power.value = SetFontString(self, tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"])
	self.Power.value:SetPoint("BOTTOMLEFT", 2, 3)

if unit ~= "player" then
	self.Info = SetFontString(self.Health, tDB["unitframes"]["font"], tDB["unitframes"]["infotextsize"])
	if unit == "target" then
		self:Tag(self.Info, '[thunder:color][thunder:name] [thunder:lvl]')
	else
		self:Tag(self.Info, '[thunder:color][thunder:name]')
	end
	self.Info:SetPoint("LEFT", 3, 0)
end

----------------------------------------------
-- Leader Icon
----------------------------------------------
	self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
	self.Leader:SetSize(10, 10)
	self.Leader:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 0, 5)

----------------------------------------------
-- Assistant Icon
----------------------------------------------
	self.Assistant = self.Health:CreateTexture(nil, "OVERLAY")
	self.Assistant:SetSize(10, 10)
	self.Assistant:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 0, 5)

----------------------------------------------
-- MasterLooter Icon
----------------------------------------------
	self.MasterLooter = self.Health:CreateTexture(nil, 'OVERLAY')
	self.MasterLooter:SetSize(10, 10)
	self.MasterLooter:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 20, 5)

----------------------------------------------
-- LFDRole Icon
----------------------------------------------
	self.LFDRole = self.Health:CreateTexture(nil, 'OVERLAY')
	self.LFDRole:SetSize(10, 10)
	self.LFDRole:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 40, 5)

----------------------------------------------
-- PvP tag
----------------------------------------------
if unit == 'player' and tDB["unitframes"]["pvp"] then
	self.PvP = self.Health:CreateTexture(nil, 'OVERLAY')
	self.PvP:SetSize(24, 24)
	self.PvP:SetPoint('TOPLEFT', self, -5, 5)
end

----------------------------------------------
-- Raid Target Icon
----------------------------------------------
	self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
	self.RaidIcon:SetSize(14, 14)
	self.RaidIcon:SetPoint("TOPRIGHT", -15, 4)

----------------------------------------------
-- Combar Mode
----------------------------------------------
if unit == 'player' then
	self.Combat = self.Health:CreateTexture(nil, 'OVERLAY')
	self.Combat:SetHeight(14)
	self.Combat:SetWidth(14)
	self.Combat:SetPoint("LEFT", 8, 0)
	self.Combat:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
	self.Combat:SetTexCoord(0.58, 0.90, 0.08, 0.41)
	self.Combat:SetVertexColor(1, 0.6, 0.6)
end
----------------------------------------------
-- Resting
----------------------------------------------
	self.Resting = self.Health:CreateTexture(nil, 'OVERLAY')
	self.Resting:SetSize(20, 20)
	self.Resting:SetPoint('TOPRIGHT', 8, 8)

----------------------------------------------
-- QuestIcon
----------------------------------------------
	self.QuestIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	self.QuestIcon:SetSize(20, 20)
	self.QuestIcon:SetPoint('BOTTOMLEFT', 15, -15)

----------------------------------------------
-- PhaseIcon
----------------------------------------------
--	self.PhaseIcon = self.Health:CreateTexture(nil, 'OVERLAY')
--	self.PhaseIcon:SetSize(20, 20)
--	self.PhaseIcon:SetPoint('BOTTOMLEFT', 35, -15)

----------------------------------------------
-- SetSize and scale
----------------------------------------------
	if unit == "player" or unit == "target" then
 		self:SetSize(ufwidth1, tDB["unitframes"]["height1"])
	elseif unit == "focus" or unit == "pet" then
		self:SetSize(tDB["unitframes"]["width2"], tDB["unitframes"]["height1"])
	else
		self:SetSize(tDB["unitframes"]["width3"], tDB["unitframes"]["height1"])
	end

	self:SetScale(1)

----------------------------------------------
-- UnitSpecific
----------------------------------------------
	
	local un = unit:match('[^%d]+')
	if(UnitSpecific[un]) then
		return UnitSpecific[un](self)
	end
end

oUF:RegisterStyle("thunder", thunderstyle)

oUF:Factory(function(self)
	self:SetActiveStyle"thunder"

	self:Spawn("targettarget", "oUF_TargetTarget"):SetPoint("CENTER", AnchorTOT)
	self:Spawn("player", "oUF_Player"):SetPoint("RIGHT", AnchorPlayer)
	self:Spawn("target", "oUF_Target"):SetPoint("LEFT", AnchorTarget)
	self:Spawn("focus", "oUF_Focus"):SetPoint("LEFT", AnchorFocus)
	self:Spawn("focustarget", "oUF_focustarget"):SetPoint("LEFT", AnchorFocusTarget)
	self:Spawn("pet", "oUF_Pet"):SetPoint("RIGHT", AnchorPet)

	if tDB["unitframes"]["hideparty"] then
		--always hide party! :3
		self:SpawnHeader("oUF_noParty", nil, "party", "showParty", true)
	end


	if tDB["unitframes"]["boss"] then
		local boss = {}
		for i = 1, MAX_BOSS_FRAMES do
			boss[i] = self:Spawn("boss"..i, "oUF_Boss"..i)
			if i == 1 then
				boss[i]:SetPoint("TOPRIGHT", AnchorBoss)
			else
				boss[i]:SetPoint("TOPRIGHT", boss[i-1], "BOTTOMRIGHT", 0, -15)
			end
		end
	end
end)