﻿----------------------------------------------------------------------------------------
-- Ingame config and modules system by Wildbreath(aka Fernir)
----------------------------------------------------------------------------------------

addonName, ns = ...

local vercheck = GetAddOnMetadata(addonName, "Version")
local media = "Interface\\Addons\\"..addonName.."\\media\\"
local settingsChanged = false
local t_unlock = false
fpDummy = function() return end
AnchorFrames = {}
INTERFACE_ACTION_BLOCKED = ""

DefaultSettings = {
	firstStart = true,
	
	["cfgMedia"] = {
		["font"] = media.."font.ttf",
		["combat_font"] = media.."combat_font.ttf",
		["fontSize"] = 11,
		["textureBlank"] = media.."WHITE64X64",
		["textureBar"] = media.."gloss",
		["textureShadow"] = media.."glowTex",
		["textureCP"] = media.."bubbleTex",
		["colorBG"] = {.01, .01, .01, 1},
		["colorBR"] = {.3, .3, .3, 1},
		["pAlpha"] = 0.8,
	},

	["cfgBars"] = {
		["invert"] = true,
		["minirightbar"] = true, --tDB["cfgBars"]["minirightbar"]
		["bottom3bar"] = false, --tDB["cfgBars"]["bottom3bar"]
		["buSize"] = 28,
		["buStanceSize"] = 28,
		["buMinipanelSize"] = 28,
		["buPetSize"] = 28,
		["buOffset"] = 4,
		["verticalstance"] = false,
		["mouseRight"] = false,
		["mouseStance"] = false,
		["mousePet"] = false,
		["hideStance"] = false,
		["font"] = media.."font.ttf",
		["fontSize"] = 11,
		["hideHotkey"] = false,
		["CCfontSize"] = 15,
	},

	["cfgMinimap"] = {
		["size"] = 122,
	},

	["cfgChat"] = {
		["font"] = media.."font.ttf",
		["copyURL"] = true,
		["chatCopy"] = true,
		["width"] = 363,
		["height"] = 134,
	},

	["cfgPanels"] = {
		["rBackground"] = true,
		["width"] = 363,
		["height"] = 134,
	},
	
	["cfgTooltips"] = {
		["anchorMouse"] = false,
		["hideCombat"] = false,
		["hudeUF"] = false,
		["hudeBu"] = false,
		["playerTitles"] = true,
	},

	["cfgData"] = {
		["font"] = media.."font.ttf",
		["fontSize"] = 10,
		["localTime"] = true,
		["24time"] = true,
		["pFPS"] = 5,
		["pMEM"] = 6,
		["pDUR"] = 4,
		["pGLD"] = 7,
		["pTIME"] = 1,
		["pFRD"] = 3,
		["pGUILD"] = 2,
		["pBGS"] = 8,
	},

	["cfgBuffs"] = {
		["showDebuffs"] = true,
		["buffsSize"] = 28,
		["debuffsSize"] = 36,
		["perRow"] = 16,
		["font"] = media.."font.ttf",
		["fontSize"] = 11,
		["timeYoffset"] = -13,
		["buffsOffset"] = 4,
	},

	["cfgLoot"] = {
		["fontSize"] = 11,
		["font"] = media.."font.ttf",
		["colorBoE"] = {1, .8, .8, 1},
	},


	["cfgTweaker"] = {
		["hideErrors"] = true,
		["declineDuels"] = true,
		["acceptGroup"] = false,
		["grabMail"] = true,
		["markMenu"] = false,
		["merchant"] = true,
	},

	["cfgNameplates"] = {
		["font"] = media.."font.ttf",
		["fontSize"] = 10,
		["fontStyle"] = nil,
		["hpHeight"] = 12,
		["hpWidth"]  = 100,
		["cbIconSize"] = 25,
		["cbHeight"] = 5,
		["cbWidth"] = 100,
		["showhealth"] = false,
	},
	
	["unitframes"] = {
		["ClassColor"] = true,
		["InvertColor"] = true,
		["font"] = media.."font.ttf",
		["fontsize"] = 10,
		["infotextsize"] = 10,
		["classbars"] = true,
		["width1"] = 200,
		["width2"] = 110,
		["width3"] = 100,
		["height1"] = 46,
		["focuspocus"] = true,
		["portraits"] = true,
		["portoveray"] = false,
		["castbars"] = true,
		["castcolor"] = {.5, .5, .5, 1},
		["castInterruptColor"] = {.22, .41, .7, 1},
		["castFailColor"] = {.9, .2, 0.1, 1},
		["castCompleteColor"] = {.1, .81, 0, 1},
		["castplayerW"] = 200,
		["castplayerH"] = 26,
		["casttargetW"] = 200,
		["casttargetH"] = 26,
		["castfocusW"] = 110,
		["castfocusH"] = 26,
		["castbarslatency"] = true,
		["pvp"] = false,
		["auras"] = true,
		["aurasize"] = 26,
		["debuffs"] = false,
		["auralimit"] = 7,
		["allinone"] = true,
		["onlyplayerdebuffs"] = false,
		["totdebuffs"] = false,
		["uicontrast"] = 0.15,
		["hideparty"] = false,
		["boss"] = true,
		["hideBlizzRaid"] = false,
		["gridWidth"] = 64,
		["gridHeight"] = 34,
		["gridOffset"] = 2,
		["gridPoint"] = "TOP",
		["gridGrowth"] = "RIGHT",
		["gridOrient"] = "HORIZONTAL",
		["gridPower"] = false,
		["gridPowerSize"] = 0.06,
		["gridIconSize"] = 11,
		["gridAuraSize"] = 18,
		["gridParty"] = 5,
		["gridPets"] = false,
		["gridMT"] = false,
		["focusdebuffs"] = true,
		["bossbuffs"] = true,
	},
}

function CreateAnchor(f, text, width, height)
	f:SetScale(1)
	f:SetFrameStrata("TOOLTIP")
	f:SetScript("OnDragStart", function(s) s:StartMoving() end)
	f:SetScript("OnDragStop", function(s) s:StopMovingOrSizing() end)
	f:SetWidth(width)
	f:SetHeight(height)
	
	local t = f:CreateTexture(nil,"OVERLAY",nil,6)
	t:SetAllPoints(f)
	t:SetTexture(0,0.6,0.6)
	t:SetAlpha(0)
	f.dragtexture = t
	
	--f:SetClampedToScreen(true)
	f:SetMovable(true)
	f:SetUserPlaced(true)
	f.dragtexture:SetAlpha(0)
	f:EnableMouse(nil)
	f:RegisterForDrag(nil)
	f:SetScript("OnEnter", nil)
	f:SetScript("OnLeave", nil)

	f.text = f:CreateFontString(nil, "OVERLAY")
	f.text:SetFont("Interface\\Addons\\TheThunderUI\\media\\font.ttf", 16)
	f.text:SetJustifyH("LEFT")
	f.text:SetShadowColor(0, 0, 0)
	f.text:SetShadowOffset(1, -1)
	f.text:SetAlpha(0)
	f.text:SetPoint("CENTER")
	f.text:SetText(text)

	tinsert(AnchorFrames, f:GetName())
end

----------------------------------------------------------------------------------------
--	Kill object function
----------------------------------------------------------------------------------------

function ThunderKill(object)
	if object.UnregisterAllEvents then
		object:UnregisterAllEvents()
	end
	object.Show = fpDummy
	object:Hide()
end

local function fpKill(object)
	if object.UnregisterAllEvents then
		object:UnregisterAllEvents()
	end
	object.Show = fpDummy
	object:Hide()
end

local function addapi(object)
	local mt = getmetatable(object).__index
--	if not object.Size then mt.Size = Size end
--	if not object.Point then mt.Point = Point end
--	if not object.SetTemplate then mt.SetTemplate = SetTemplate end
--	if not object.CreatePanel then mt.CreatePanel = CreatePanel end
--	if not object.CreateBackdrop then mt.CreateBackdrop = CreateBackdrop end
--	if not object.CreateShadow then mt.CreateShadow = CreateShadow end
	if not object.fpKill then mt.fpKill = fpKill end
--	if not object.StyleButton then mt.StyleButton = StyleButton end
--	if not object.Width then mt.Width = Width end
--	if not object.Height then mt.Height = Height end
--	if not object.FontString then mt.FontString = FontString end
--	if not object.StripTextures then mt.StripTextures = StripTextures end
end

local handled = {["Frame"] = true}
local object = CreateFrame("Frame")
addapi(object)
addapi(object:CreateTexture())
addapi(object:CreateFontString())

object = EnumerateFrames()
while object do
	if not handled[object:GetObjectType()] then
		addapi(object)
		handled[object:GetObjectType()] = true
	end

	object = EnumerateFrames(object)
end

----------------------------------------------------------------------------------------
--	setup vars
----------------------------------------------------------------------------------------

local function setupVars()
	SetCVar("buffDurations", 1)
	SetCVar("consolidateBuffs", 0)
	SetCVar("autoLootDefault", 1)
	SetCVar("lootUnderMouse", 1)
	SetCVar("autoSelfCast", 1)
	SetCVar("mapQuestDifficulty", 1)
	SetCVar("scriptErrors", 0)
	SetCVar("nameplateShowFriends", 0)
	SetCVar("nameplateShowFriendlyPets", 0)
	SetCVar("nameplateShowFriendlyGuardians", 0)
	SetCVar("nameplateShowFriendlyTotems", 0)
	SetCVar("nameplateShowEnemies", 1)
	SetCVar("nameplateShowEnemyPets", 0)
	SetCVar("nameplateShowEnemyGuardians", 0)
	SetCVar("nameplateShowEnemyTotems", 1)
	SetCVar("ShowClassColorInNameplate", 1)
	
	SetCVar("bloattest", 0)
	SetCVar("bloatnameplates", 0.0)
	SetCVar("bloatthreat", 0)
	
	SetCVar("screenshotQuality", 8)
	SetCVar("cameraDistanceMax", 50)
	SetCVar("cameraDistanceMaxFactor", 3.4)
	SetCVar("chatMouseScroll", 1)
	SetCVar("chatStyle", "classic")
	SetCVar("WholeChatWindowClickable", 0)
	SetCVar("ConversationMode", "inline")
	SetCVar("CombatDamage", 1)
	SetCVar("CombatHealing", 1)
	SetCVar("showTutorials", 0)
	SetCVar("showNewbieTips", 0)
end

local function SetSkada()
if(SkadaDB) then table.wipe(SkadaDB) end

SkadaDB = {
	["profiles"] = {
		["Default"] = {
			["windows"] = {
				{
					["barheight"] = 14,
					["barmax"] = 7,
					["scale"] = 1,
					["barcolor"] = {
						["b"] = 0.5,
						["g"] = 0.5,
						["r"] = 0.5,
					},
					["classcolortext"] = true,
					["classcolorbars"] = false,
					["barfontsize"] = 10,
					["title"] = {
						["color"] = {
							["a"] = 0.8,
							["r"] = 0.5,
							["g"] = 0.5,
							["b"] = 0.5,
						},
						["texture"] = "Gloss",
					},
					["spark"] = false,
					["enablebackground"] = true,
					["barspacing"] = 1,
					["background"] = {
						["borderthickness"] = 2,
						["height"] = 127,
					},
					["y"] = 150,
					["x"] = -149,
					["name"] = "Skada",
					["baraltcolor"] = {
						["a"] = 0,
						["b"] = 0.04,
						["g"] = 0.04,
						["r"] = 0.04,
					},
					["point"] = "BOTTOMRIGHT",
					["enabletitle"] = true,
					["barwidth"] = 159,
					["barslocked"] = true,
				}, -- [1]
			},
			["icon"] = {
				["hide"] = true,
			},
			["showranks"] = false,
		},
	},
}
end

function AnchorsUnlock()
	print("UI: all frames unlocked")
	for _, v in pairs(AnchorFrames) do
		f = _G[v]
		if f and f:IsUserPlaced() then
			f.dragtexture:SetAlpha(0.7)
			f.text:SetAlpha(1)
			f:EnableMouse(true)
			f:RegisterForDrag("LeftButton")
		end
	end
end

function AnchorsLock()
	print("UI: all frames locked")
	for _, v in pairs(AnchorFrames) do
		f = _G[v]
		if f and f:IsUserPlaced() then
			f.dragtexture:SetAlpha(0)
			f.text:SetAlpha(0)
			f:EnableMouse(nil)
			f:RegisterForDrag(nil)
		end
	end
end

function AnchorsReset()
	for _, v in pairs(AnchorFrames) do
		f = _G[v]
		if f and f:IsUserPlaced() then
			f:SetUserPlaced(false)
		end
	end
	ReloadUI()
end

local function SlashCmd(cmd)
	if (cmd:match"reset") then
		AnchorsReset()
	else
		if t_unlock == false then
			t_unlock = true
			AnchorsUnlock()
		elseif t_unlock == true then
			t_unlock = false
			AnchorsLock()
		end
	end
end

SlashCmdList["ui"] = SlashCmd;
SLASH_ui1 = "/ui";

local function SetValue(group, option, value, parent)
	if parent then
		tDB[parent][group][option] = value
		settingsChanged = true
	else
		tDB[group][option] = value
		settingsChanged = true
	end
end

local NewButton = function(text,parent)
	local result = CreateFrame("Button", "btn_"..parent:GetName(), parent, "UIPanelButtonTemplate")
	if not Lc[text] then
		result:SetText(text)
	else
		result:SetText(Lc[text])
	end
	return result
end

local NewLabel = function(text,parent, justify)
	local label = parent:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	if not Lc[text] then
		label:SetText(text)
	else
		label:SetText(Lc[text])
	end
	label:SetJustifyH(justify or "LEFT")
	return label
end

parseOptions = function(mainframe, group, opt, parent)
	if not opt then return end
	
	local scrollf = CreateFrame("ScrollFrame", "interface_scrollf"..group, mainframe, "UIPanelScrollFrameTemplate")
	local frame = CreateFrame("frame", group, scrollf)
	scrollf:SetScrollChild(frame)
	scrollf:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 20, -40)
	scrollf:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT", -40, 45)
	frame:SetPoint("TOPLEFT")
	frame:SetWidth(130)
	frame:SetHeight(130)
	
	local offset=5
	local tmparr = {}
	for option, value in pairs(opt) do
		table.insert(tmparr, { ["option"] = option, ["value"] = value })
	end
	table.sort(tmparr, function(a,b) return tostring(a.option) < tostring(b.option) end)
	
	for index, array in ipairs(tmparr) do
		local option, value = array.option, array.value
		if type(value) == "boolean" then
			local button = CreateFrame("CheckButton", "config_"..option, frame, "InterfaceOptionsCheckButtonTemplate")
			if not Lc[option] then
				_G["config_"..option.."Text"]:SetText(option)
			else
				_G["config_"..option.."Text"]:SetText(Lc[option])
			end
			button:SetChecked(value)
			button:SetScript("OnClick", function(self) SetValue(group,option,(self:GetChecked() and true or false), parent); _G[self:GetName().."Text"]:SetTextColor(.1,1,.1); end)
			button:SetPoint("TOPLEFT", 15, -(offset))
			offset = offset+25
		elseif type(value) == "number" or type(value) == "string" and not value:find("function") then
			local label = NewLabel(option, frame)
			label:SetPoint("TOPLEFT", 15, -(offset))
			
			local editbox = CreateFrame("EditBox", "editbox_"..option, frame)
			editbox:SetAutoFocus(false)
			editbox:SetMultiLine(false)
			editbox:SetWidth(220)
			editbox:SetHeight(20)
			editbox:SetMaxLetters(255)
			editbox:SetTextInsets(3,0,0,0)
			editbox:SetJustifyH("LEFT")
			editbox:SetBackdrop({
				bgFile = "Interface\\Buttons\\WHITE8x8", 
				tiled = false,
			})
			editbox:SetBackdropColor(0,0,0,0.5)
			editbox:SetBackdropBorderColor(0,0,0,1)
			editbox:SetFontObject("GameFontHighlight")
			editbox:SetPoint("TOPLEFT", 15, -(offset+20))
			editbox:SetText(value)
			
			local save = CreateFrame("button", option.."SaveButton", frame)
			save:SetNormalTexture("Interface\\Buttons\\UI-Panel-SmallerButton-Up")
			save:SetPushedTexture("Interface\\Buttons\\UI-Panel-SmallerButton-Down")
			save:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
			save:SetWidth(32)
			save:SetHeight(32)
			save:SetPoint("LEFT", editbox, "RIGHT", 5, 0)
			save:SetScript("OnClick", function(self) 
				editbox:ClearFocus()
				editbox:SetBackdropBorderColor(.2,1,.2)
				if type(value) == "number" then
					SetValue(group,option,tonumber(editbox:GetText()), parent)
				else
					SetValue(group,option,tostring(editbox:GetText()), parent)
				end
			end)
			
			offset = offset+45
		elseif type(value) == "table" then
			if value.vtype ~= nil then
				
			else
				if #value <= 4 and type(value[1]) == "number" and value[1] <= 1 and value[2] <= 1 and value[3] <= 1 then
					local label = NewLabel(option, frame)
			
					local but = CreateFrame("Button", "btnt_"..option, frame)
					but:SetWidth(20)
					but:SetHeight(20)
					but:SetPoint("TOPLEFT", 15, -(offset))
					
					label:SetPoint("LEFT", but, "RIGHT", 5, 0)
					
					but.tex = but:CreateTexture(nil)
					but.tex:SetTexture(value[1], value[2], value[3], value[4] or 1)
					but.tex:SetPoint("TOPLEFT", 2, -2)
					but.tex:SetPoint("BOTTOMRIGHT", -2, 2)
					offset = offset+25
					
					but:SetScript("OnClick", function(self) 
						self = self.tex
					
						local function ColorCallback(self,r,g,b,a,isAlpha)
							but.tex:SetTexture(r, g, b, a)
							
							if not ColorPickerFrame:IsVisible() then
								--colorpicker is closed, color callback is first, ignore it, alpha callback is the final call after it closes so confirm now
								if isAlpha then
									value = {r, g, b, a}
									if parent then
										tDB[parent][group][option] = {r, g, b, a}
									else
										tDB[group][option] = {r, g, b, a}
									end
									but:SetBackdropBorderColor(.1, 1, .1)
								end
							end
						end
						
						HideUIPanel(ColorPickerFrame)
						ColorPickerFrame:SetFrameStrata("FULLSCREEN_DIALOG")
						
						ColorPickerFrame.func = function()
							local r,g,b = ColorPickerFrame:GetColorRGB()
							local a = 1 - OpacitySliderFrame:GetValue()
							ColorCallback(self,r,g,b,a, true)
						end
						
						ColorPickerFrame.hasOpacity = value[4] or false
						ColorPickerFrame.opacityFunc = function()
							local r,g,b = ColorPickerFrame:GetColorRGB()
							local a = 1 - OpacitySliderFrame:GetValue()
							ColorCallback(self,r,g,b,a,true)
						end
						
						local r, g, b, a = value[1], value[2], value[3], value[4]
						ColorPickerFrame.opacity = 1 - (a or 0)
						ColorPickerFrame:SetColorRGB(r, g, b)
						
						ColorPickerFrame.cancelFunc = function()
							ColorCallback(self,r,g,b,a,true)
						end
						ShowUIPanel(ColorPickerFrame)
					end)
				end
			end
		elseif type(value) == "string" and value:find("function") then
			local button = NewButton(option, frame)
			button:SetHeight(20)
			button:SetWidth(90)
			local func = value:gsub("function(.+)", "%1")
			button:SetScript("OnClick", function(self) RunScript(func) end)
			button:SetPoint("TOPLEFT", 15, -(offset))
			offset = offset+25
		end
	end
			
   frame:SetHeight(offset)
	mainframe:Hide()
end


local LaunchMain = function(settings)
	_, tDB["playerclass"] = UnitClass("player")

----------------------------------------------------------------------------------------
-- Border and Background function
----------------------------------------------------------------------------------------

	function CreateBorder(f)
		local border = CreateFrame("Frame", nil, f)
		border:SetFrameLevel(f:GetFrameLevel()-1)
		border:SetPoint("TOPLEFT", -1, 1)
		border:SetPoint("BOTTOMRIGHT", 1, -1)
		border:SetBackdrop({
		  edgeFile = tDB["cfgMedia"]["textureBlank"], edgeSize = 3, 
		  insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})
		border:SetBackdropBorderColor(unpack(tDB["cfgMedia"]["colorBG"]))
	end

	function CreateShadow(f)
		local shadow = CreateFrame("Frame", nil, f)
		shadow:SetPoint("TOPLEFT", -4, 4)
		shadow:SetPoint("BOTTOMRIGHT", 4, -4)
		shadow:SetFrameStrata("BACKGROUND")
		shadow:SetFrameLevel(1)
		shadow:SetBackdrop({
			edgeFile = tDB["cfgMedia"]["textureShadow"], edgeSize = 5,
			insets = {left = 3, right = 3, top = 3, bottom = 3}
		})
		shadow:SetBackdropBorderColor(0, 0, 0)
	end

	function CreateBG(f, tp)
		local BG = CreateFrame("Frame", nil, f)
		BG:SetFrameLevel(f:GetFrameLevel()-1)
		BG:SetAllPoints(f)
		BG:SetBackdrop({
		  bgFile = tDB["cfgMedia"]["textureBlank"],
		})
		BG:SetBackdropColor(unpack(tDB["cfgMedia"]["colorBG"]))
		
		if tp then
			BG:SetAlpha(tDB["cfgMedia"]["pAlpha"])
		end
	end


	function SetTemplate(f, style, tp)
		f:SetBackdrop({
			edgeFile = tDB["cfgMedia"]["textureBlank"], edgeSize = 1,
		})
		f:SetBackdropBorderColor(unpack(tDB["cfgMedia"]["colorBR"]))
		if style == "button" then
		--	CreateBorder(f)
		elseif style == "bushadow" then
		--	CreateBorder(f)
			CreateShadow(f)
		elseif style == "background" then
			f:SetFrameLevel(10)
			f:SetFrameStrata("BACKGROUND")
			CreateBG(f, tp)
			CreateShadow(f)
		elseif style == "skada" then
			f:SetFrameLevel(15)
			f:SetFrameStrata("BACKGROUND")
			CreateBG(f, tp)
		--	CreateShadow(f)
		elseif style == "editbox" then
		--	f:SetFrameStrata("BACKGROUND")
			CreateBG(f)
			CreateShadow(f)			
		end
	end

	function StyleButton(b) 
		local name = b:GetName()
	 
		local button          = _G[name]
		local icon            = _G[name.."Icon"]
		local count           = _G[name.."Count"]
		local border          = _G[name.."Border"]
		local hotkey          = _G[name.."HotKey"]
		local cooldown        = _G[name.."Cooldown"]
		local nametext        = _G[name.."Name"]
		local flash           = _G[name.."Flash"]
		local normaltexture   = _G[name.."NormalTexture"]
		local icontexture     = _G[name.."IconTexture"]
		
		local hover = b:CreateTexture("frame", nil, self) -- hover
		hover:SetTexture(1,1,1,0.3)
		hover:SetHeight(button:GetHeight())
		hover:SetWidth(button:GetWidth())
		hover:SetPoint("TOPLEFT",button,1,-1)
		hover:SetPoint("BOTTOMRIGHT",button,-1,1)
		button:SetHighlightTexture(hover)

		local pushed = b:CreateTexture("frame", nil, self) -- pushed
		pushed:SetTexture(0.9,0.8,0.1,0.3)
		pushed:SetHeight(button:GetHeight())
		pushed:SetWidth(button:GetWidth())
		pushed:SetPoint("TOPLEFT",button,1,-1)
		pushed:SetPoint("BOTTOMRIGHT",button,-1,1)
		button:SetPushedTexture(pushed)
		
		if cooldown then
			cooldown:ClearAllPoints()
			cooldown:SetPoint("TOPLEFT",button,1,-1)
			cooldown:SetPoint("BOTTOMRIGHT",button,-1,1)
		end
	end

	print("|cff9DC7CCThunderUI "..vercheck.."|r loaded")
end

StaticPopupDialogs["INSTALL"] = {
	text = "ThunderUI Install.|nNeed to reload ui for save all settings.|n In future you can change settings in |cffaaaaff\"Settings - Interface - Addons - ThunderUI\"|r by press a key |cffaaffaa\"Save\"|r",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function() tDB.firstStart = false; setupVars(); SetSkada(); ReloadUI(); end,
	OnCancel = function() tDB.firstStart = true end,
	timeout = 0,
	whileDead = 1,
}

StaticPopupDialogs["SAVEOPTS"] = {
	text = "Settings changed.|nReload UI?",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function() ReloadUI(); end,
	OnCancel = function() end,
	timeout = 0,
	whileDead = 1,
}

ThunderUI = CreateFrame("frame", "ThunderUI", UIParent)
ThunderUI.modules = {}
ThunderUI:RegisterEvent("VARIABLES_LOADED")
ThunderUI:SetScript("OnEvent", function()
	if not tDB or tDB.firstStart then
		 StaticPopup_Show("INSTALL")
	end
	tDB = tDB or DefaultSettings

	for k,v in pairs(DefaultSettings) do
		if tDB[k] == nil then
			tDB[k] = v
			print("|cffaaffaaRestored|r "..k.." |cffaaffaaoption|r")
		end
		if type(v) == "table" then
			for n,m in pairs(v) do
				if tDB[k][n] == nil then
					tDB[k][n] = m
					print("|cffaaffaaRestored|r "..k.." |cffaaffaaoption. New value|r "..n)
				end
			end
		end
	end

	InterfaceOptionsFrameOkay:HookScript("OnClick", function() 
		if settingsChanged then
			StaticPopup_Show("SAVEOPTS")
		end
	end)
	
	if not tDB.modules then tDB.modules = {} end
	ThunderUI.main = CreateFrame("frame", "|cff00DDAAThunderUI|r", InterfaceOptionsFramePanelContainer)
	ThunderUI.main.name = "|cff9DC7CCThe Thunder UI|r"
	InterfaceOptions_AddCategory(ThunderUI.main)
		
	parseOptions(ThunderUI.main, "cfgMedia", tDB["cfgMedia"])
	
	LaunchMain(tDB)
	
	local resetm = NewButton(Lc["Reset"], ThunderUI.main)
	resetm:SetWidth(90)
	resetm:SetHeight(20)
	resetm:SetPoint("BOTTOMLEFT",10, 10)
	resetm:SetScript("OnClick", function(self) tDB = nil ReloadUI() end)
	
	local savem = NewButton(Lc["Save"], ThunderUI.main)
	savem:SetWidth(90)
	savem:SetHeight(20)
	savem:SetPoint("BOTTOMRIGHT", -10, 10)
	savem:SetScript("OnClick", function(self) ReloadUI() end)
		
	table.sort(ThunderUI.modules, function(a,b) return a.name < b.name end)
	for i, module in pairs(ThunderUI.modules) do
		if tDB.modules[module.name] == nil then tDB.modules[module.name] = true end
			
		local childpanel = CreateFrame("frame", module.name, InterfaceOptionsFramePanelContainer)
		childpanel.name = Lc[module.name]
		childpanel.parent = ThunderUI.main.name
		
		local label = NewLabel(module.name, childpanel)
		label:SetPoint("TOP", 0, -10)

		local checkbox = CreateFrame("CheckButton", "cb_module"..module.name, childpanel, "InterfaceOptionsCheckButtonTemplate")
		if tDB.modules[module.name] then
			_G["cb_module"..module.name.."Text"]:SetText(Lc["Enable"])
		else
			_G["cb_module"..module.name.."Text"]:SetText(Lc["Disable"])
		end
		checkbox:SetChecked(tDB.modules[module.name])
		checkbox:SetScript("OnClick", function() 
			tDB.modules[module.name] = not tDB.modules[module.name] 
			if tDB.modules[module.name] then
				_G["cb_module"..module.name.."Text"]:SetText(Lc["Enable"])
			else
				_G["cb_module"..module.name.."Text"]:SetText(Lc["Disable"])
			end
		end)
		checkbox:SetPoint("TOPLEFT", childpanel, 20, -20)
			
		InterfaceOptions_AddCategory(childpanel)
		
		local reset = NewButton(Lc["Reset module options"], childpanel)
		reset:SetWidth(140)
		reset:SetHeight(20)
		reset:SetPoint("BOTTOMLEFT",10, 10)
		reset:SetScript("OnClick", function(self) tDB[module.name] = nil ReloadUI() end)
	
		local save = NewButton("Save", childpanel)
		save:SetWidth(90)
		save:SetHeight(20)
		save:SetPoint("BOTTOMRIGHT", -10, 10)
		save:SetScript("OnClick", function(self) ReloadUI() end)

		module.Init()
		
		parseOptions(childpanel, module.name, tDB[module.name])
   end
   ThunderUI:UnregisterEvent("VARIABLES_LOADED")
   ThunderUI:SetScript("OnEvent", nil)
end)

SlashCmdList['THUNDER'] = function()
		InterfaceOptionsFrame_OpenToCategory'|cff9DC7CCThe Thunder UI|r'
end
SLASH_THUNDER1 = '/thunder'