﻿AnchorBar1 = CreateFrame("Frame","Move_Bar1",UIParent)
AnchorBar1:SetPoint("BOTTOM", 0, 20)
CreateAnchor(AnchorBar1, "Move main actionbar", 20, 20)

AnchorBar2 = CreateFrame("Frame","Move_Bar2",UIParent)
AnchorBar2:SetPoint("RIGHT", -20, 0)
CreateAnchor(AnchorBar2, "Move right actionbar", 20, 20)

AnchorBar3 = CreateFrame("Frame","Move_Bar3",UIParent)
AnchorBar3:SetPoint("BOTTOMRIGHT", -313, 44)
CreateAnchor(AnchorBar3, "Move small actionbar", 20, 20)

AnchorPetBar = CreateFrame("Frame","Move_PetBar",UIParent)
AnchorPetBar:SetPoint("BOTTOM", 0, 120)
CreateAnchor(AnchorPetBar, "Move pet bar", 20, 20)

AnchorStance = CreateFrame("Frame","Move_Stance",UIParent)
AnchorStance:SetPoint("TOPLEFT", 15, -15)
CreateAnchor(AnchorStance, "Move stance bar", 20, 20)

AnchorTotem = CreateFrame("Frame","Move_Totem",UIParent, "SecureHandlerStateTemplate")
AnchorTotem:SetPoint("BOTTOM", 0, 142)
CreateAnchor(AnchorTotem, "Move totem bar", 20, 20)

AnchorVehicle = CreateFrame("Frame","Move_Vehicle",UIParent)
AnchorVehicle:SetPoint("BOTTOM", 185, 132)
CreateAnchor(AnchorVehicle, "Move exit button", 20, 20)

local module = {}
module.name = "cfgBars"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB

----------------------------------------------------------------------------------------
-- hide blizzard stuff
----------------------------------------------------------------------------------------

InterfaceOptionsActionBarsPanelBottomLeft:Hide()
InterfaceOptionsActionBarsPanelBottomRight:Hide()
InterfaceOptionsActionBarsPanelRight:Hide()
InterfaceOptionsActionBarsPanelRightTwo:Hide()
InterfaceOptionsActionBarsPanelAlwaysShowActionBars:Hide()

MainMenuBar:SetScale(0.00001)
MainMenuBar:EnableMouse(false)
VehicleMenuBar:SetScale(0.00001)
VehicleMenuBar:EnableMouse(false)

local FramesToHide = {
	MainMenuBar,
	MainMenuBarArtFrame,
	BonusActionBarFrame,
	VehicleMenuBar,
	PossessBarFrame,
}

for _, f in pairs(FramesToHide) do
	if f:GetObjectType() == "Frame" then
		f:UnregisterAllEvents()
	end
	if f ~= MainMenuBar then --patch 4.0.6 fix found by tukz
		f:HookScript("OnShow", function(s) s:Hide(); end)
		f:Hide()
	end
	f:SetAlpha(0)
end

-- code by tukz/evl22
-- fix main bar keybind not working after a talent switch. :X
hooksecurefunc('TalentFrame_LoadUI', function()
	PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
end)

------------------------------------------------------------------------
--	Show button grid and all action bars
------------------------------------------------------------------------

local GridOnLogon = CreateFrame("Frame")
GridOnLogon:RegisterEvent("PLAYER_ENTERING_WORLD")
GridOnLogon:SetScript("OnEvent", function()
	GridOnLogon:UnregisterEvent("PLAYER_ENTERING_WORLD")
	GridOnLogon:SetScript("OnEvent", nil)

	-- enable action bars
		SetActionBarToggles( 1, 1, 1, 1, 0 )
		ActionButton_HideGrid = function() end
		SetCVar("alwaysShowActionBars", 0)

	for i = 1, 12 do
		local button = _G[format("ActionButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)

		button = _G[format("BonusActionButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)

		button = _G[format("MultiBarRightButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)

		button = _G[format("MultiBarBottomRightButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)

		button = _G[format("MultiBarLeftButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)

		button = _G[format("MultiBarBottomLeftButton%d", i)]
		button:SetAttribute("showgrid", 1)
		ActionButton_ShowGrid(button)
	end
end)

------------------------------------------------------------------------
--	Set general anchor size
------------------------------------------------------------------------

AnchorBar1:SetWidth(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
if tDB["cfgBars"]["bottom3bar"] then
	AnchorBar1:SetHeight(tDB["cfgBars"]["buSize"]*3+tDB["cfgBars"]["buOffset"]*2)
else
	AnchorBar1:SetHeight(tDB["cfgBars"]["buSize"]*2+tDB["cfgBars"]["buOffset"])
end

AnchorBar2:SetHeight(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
if tDB["cfgBars"]["minirightbar"] and tDB["cfgBars"]["bottom3bar"] then
	AnchorBar2:SetWidth(tDB["cfgBars"]["buSize"])
elseif (tDB["cfgBars"]["minirightbar"] ~= true and tDB["cfgBars"]["bottom3bar"] == true) or (tDB["cfgBars"]["minirightbar"] == true and tDB["cfgBars"]["bottom3bar"] ~= true) then
	AnchorBar2:SetWidth(tDB["cfgBars"]["buSize"]*2+tDB["cfgBars"]["buOffset"])
else
	AnchorBar2:SetWidth(tDB["cfgBars"]["buSize"]*3+tDB["cfgBars"]["buOffset"]*2)
end

if tDB["cfgBars"]["minirightbar"] then
	AnchorBar3:SetWidth(tDB["cfgBars"]["buMinipanelSize"]*2+tDB["cfgBars"]["buOffset"])
	AnchorBar3:SetHeight(tDB["cfgBars"]["buMinipanelSize"]*4+tDB["cfgBars"]["buOffset"]*3)
end

----------------------------------------------------------------------------------------
-- fBar 1
-- MAJOR props to tukz for the RegisterStateDriver
-- settings for actionbar1/bonusactionbar -- zork
----------------------------------------------------------------------------------------
local fbar1 = CreateFrame("Frame","rABS_MainMenuBar",UIParent, "SecureHandlerStateTemplate")
fbar1:SetWidth(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
fbar1:SetHeight(tDB["cfgBars"]["buSize"])
if tDB["cfgBars"]["invert"] then
	fbar1:SetPoint("TOPLEFT", AnchorBar1)
else
	fbar1:SetPoint("BOTTOMLEFT", AnchorBar1)
end
fbar1:SetScale(1)

local Page = {
	["DRUID"] = "[bonusbar:1,nostealth] 7; [bonusbar:1,stealth] %s; [bonusbar:2] 8; [bonusbar:3] 9; [bonusbar:4] 10;",
	["WARRIOR"] = "[bonusbar:1] 7; [bonusbar:2] 8; [bonusbar:3] 9;",
	["PRIEST"] = "[bonusbar:1] 7;",
	["ROGUE"] = "[bonusbar:1] 7; [form:3] 7;",
	["WARLOCK"] = "[form:2] 7;",
	["DEFAULT"] = "[bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6; [bonusbar:5] 11;",
}

local function GetBar()
	local condition = Page["DEFAULT"]
	local page = Page[tDB["playerclass"]]
	if page then
		if tDB["playerclass"] == "DRUID" then
			-- Handles prowling, prowling has no real stance, so this is a hack which utilizes the Tree of Life bar for non-resto druids.
			if IsSpellKnown(33891) then -- Tree of Life form
				page = page:format(7)
			else
				page = page:format(8)
			end
		end
		condition = condition.." "..page
	end
	condition = condition.." 1"
	return condition
end

fbar1:RegisterEvent("PLAYER_LOGIN")
fbar1:RegisterEvent("PLAYER_ENTERING_WORLD")
fbar1:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE")
fbar1:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
fbar1:RegisterEvent("BAG_UPDATE")
fbar1:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_LOGIN" then
		local bu1
		for i = 1, NUM_ACTIONBAR_BUTTONS do
			bu1 = _G["ActionButton"..i]
			self:SetFrameRef("ActionButton"..i, bu1)
		end

		self:Execute([[
			buttons = table.new()
			for i = 1, 12 do
				table.insert(buttons, self:GetFrameRef("ActionButton"..i))
			end
		]])

		self:SetAttribute("_onstate-page", [[
			for i, bu1 in ipairs(buttons) do
				bu1:SetAttribute("actionpage", tonumber(newstate))
			end
		]])

		RegisterStateDriver(self, "page", GetBar())
	elseif event == "PLAYER_ENTERING_WORLD" then
		MainMenuBar_UpdateKeyRing()
		local bu1
		for i = 1, 12 do
			bu1 = _G["ActionButton"..i]
			bu1:SetSize(tDB["cfgBars"]["buSize"], tDB["cfgBars"]["buSize"])
			bu1:ClearAllPoints()
			bu1:SetParent(self)
			if i == 1 then
				bu1:SetPoint("BOTTOMLEFT", fbar1, 0,0)
			else
				local previous = _G["ActionButton"..i-1]
				bu1:SetPoint("LEFT", previous, "RIGHT", tDB["cfgBars"]["buOffset"], 0)
			end
		end
	else
		 MainMenuBar_OnEvent(self, event, ...)
	end
end)

----------------------------------------------------------------------------------------
-- fBar 2
----------------------------------------------------------------------------------------
local fbar2 = CreateFrame("Frame","rABS_MultiBarBottomLeft",UIParent, "SecureHandlerStateTemplate")
fbar2:SetWidth(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
fbar2:SetHeight(tDB["cfgBars"]["buSize"])
if tDB["cfgBars"]["bottom3bar"] then
	fbar2:SetPoint("BOTTOMLEFT", AnchorBar1, 0, tDB["cfgBars"]["buSize"]+tDB["cfgBars"]["buOffset"])
elseif tDB["cfgBars"]["invert"] then
	fbar2:SetPoint("BOTTOMLEFT", AnchorBar1)
else
	fbar2:SetPoint("TOPLEFT", AnchorBar1)
end
fbar2:SetScale(1)

MultiBarBottomLeft:SetParent(fbar2)

for i=1, 12 do
	local bu2 = _G["MultiBarBottomLeftButton"..i]
	bu2:SetSize(tDB["cfgBars"]["buSize"], tDB["cfgBars"]["buSize"])
	bu2:ClearAllPoints()
	if i == 1 then
		bu2:SetPoint("BOTTOMLEFT", fbar2, 0,0)
	else
		local previous = _G["MultiBarBottomLeftButton"..i-1]
		bu2:SetPoint("LEFT", previous, "RIGHT", tDB["cfgBars"]["buOffset"], 0)
	end
end

----------------------------------------------------------------------------------------
-- fBar 3
----------------------------------------------------------------------------------------
local fbar3 = CreateFrame("Frame","rABS_MultiBarBottomRight",UIParent, "SecureHandlerStateTemplate")
if tDB["cfgBars"]["minirightbar"] then
	fbar3:SetAllPoints(AnchorBar3)
else
	fbar3:SetHeight(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
	fbar3:SetWidth(tDB["cfgBars"]["buSize"])
	fbar3:SetPoint("TOPLEFT", AnchorBar2)
end
fbar3:SetScale(1)

MultiBarBottomRight:SetParent(fbar3)

for i=1, 12 do
	local bu3 = _G["MultiBarBottomRightButton"..i]
	if tDB["cfgBars"]["minirightbar"] then
		bu3:SetSize(tDB["cfgBars"]["buMinipanelSize"], tDB["cfgBars"]["buMinipanelSize"])
	else
		bu3:SetSize(tDB["cfgBars"]["buSize"], tDB["cfgBars"]["buSize"])
	end
	bu3:ClearAllPoints()
	if i == 1 then
		bu3:SetPoint("TOPLEFT", fbar3, 0,0)
	elseif tDB["cfgBars"]["minirightbar"] and i == 5 then
		bu3:SetPoint("LEFT", _G["MultiBarBottomRightButton1"], "RIGHT", tDB["cfgBars"]["buOffset"], 0)
	elseif tDB["cfgBars"]["minirightbar"] and i > 8 then
		ThunderKill(bu3)
	else
		local previous = _G["MultiBarBottomRightButton"..i-1]
		bu3:SetPoint("TOP", previous, "BOTTOM", 0, -tDB["cfgBars"]["buOffset"])
	end
end

----------------------------------------------------------------------------------------
-- fBar 4
----------------------------------------------------------------------------------------

local fbar4 = CreateFrame("Frame","rABS_MultiBarRight",UIParent, "SecureHandlerStateTemplate")
if tDB["cfgBars"]["bottom3bar"] then
	fbar4:SetHeight(tDB["cfgBars"]["buSize"])
	fbar4:SetWidth(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
else
	fbar4:SetHeight(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
	fbar4:SetWidth(tDB["cfgBars"]["buSize"])
end

if tDB["cfgBars"]["bottom3bar"] and tDB["cfgBars"]["invert"] then
	fbar4:SetPoint("BOTTOMLEFT", AnchorBar1)
elseif tDB["cfgBars"]["bottom3bar"] then
	fbar4:SetPoint("TOPLEFT", AnchorBar1)
elseif tDB["cfgBars"]["minirightbar"] then
	fbar4:SetPoint("TOPLEFT", AnchorBar2)
else
	fbar4:SetPoint("TOPLEFT", AnchorBar2, tDB["cfgBars"]["buSize"]+tDB["cfgBars"]["buOffset"], 0)
end

fbar4:SetScale(1)

MultiBarRight:SetParent(fbar4)

for i=1, 12 do
	local bu4 = _G["MultiBarRightButton"..i]
	bu4:ClearAllPoints()
	bu4:SetSize(tDB["cfgBars"]["buSize"], tDB["cfgBars"]["buSize"])
	if i == 1 then
		bu4:SetPoint("TOPLEFT", fbar4, 0,0)
	else
		local previous = _G["MultiBarRightButton"..i-1]
		if tDB["cfgBars"]["bottom3bar"] then
			bu4:SetPoint("LEFT", previous, "RIGHT", tDB["cfgBars"]["buOffset"], 0)
		else
			bu4:SetPoint("TOP", previous, "BOTTOM", 0, -tDB["cfgBars"]["buOffset"])
		end
	end
end

----------------------------------------------------------------------------------------
-- fBar 5
----------------------------------------------------------------------------------------

local fbar5 = CreateFrame("Frame","rABS_MultiBarLeft",UIParent, "SecureHandlerStateTemplate")
fbar5:SetHeight(tDB["cfgBars"]["buSize"]*12+tDB["cfgBars"]["buOffset"]*11)
fbar5:SetWidth(tDB["cfgBars"]["buSize"])
fbar5:SetPoint("TOPRIGHT", AnchorBar2)
fbar5:SetScale(1)

MultiBarLeft:SetParent(fbar5)

for i=1, 12 do
	local bu5 = _G["MultiBarLeftButton"..i]
	bu5:ClearAllPoints()
	bu5:SetSize(tDB["cfgBars"]["buSize"], tDB["cfgBars"]["buSize"])
	if i == 1 then
		bu5:SetPoint("TOPLEFT", fbar5, 0,0)
	else
		local previous = _G["MultiBarLeftButton"..i-1]
		bu5:SetPoint("TOP", previous, "BOTTOM", 0, -tDB["cfgBars"]["buOffset"])
	end
end

----------------------------------------------------------------------------------------
-- mouseover right
----------------------------------------------------------------------------------------

if tDB["cfgBars"]["mouseRight"] then
	local MouseRightZone = CreateFrame("Frame",nil,UIParent)
	MouseRightZone:SetAllPoints(AnchorBar2)
	function rightlighton(alpha)
		if tDB["cfgBars"]["minirightbar"] ~= true and MultiBarBottomRight:IsShown() then
			for i=1, 12 do
				local bu3 = _G["MultiBarBottomRightButton"..i]
				bu3:SetAlpha(alpha)
			end
		end
		if tDB["cfgBars"]["bottom3bar"] ~= true and MultiBarRight:IsShown() then
			for i=1, 12 do
				local bu4 = _G["MultiBarRightButton"..i]
				bu4:SetAlpha(alpha)
			end
		end
		if MultiBarLeft:IsShown() then
			for i=1, 12 do
				local bu5 = _G["MultiBarLeftButton"..i]
				bu5:SetAlpha(alpha)
			end
		end
	end

	MouseRightZone:EnableMouse(true)
	MouseRightZone:SetScript("OnEnter", function(self) rightlighton(1) end)
	MouseRightZone:SetScript("OnLeave", function(self) rightlighton(0) end)
	for i=1, 12 do
		if tDB["cfgBars"]["minirightbar"] ~= true then
			local bu3 = _G["MultiBarBottomRightButton"..i]
			bu3:SetAlpha(0)
			bu3:HookScript("OnEnter", function(self) rightlighton(1) end)
			bu3:HookScript("OnLeave", function(self) rightlighton(0) end)
		end
		
		if tDB["cfgBars"]["bottom3bar"] ~= true then
			local bu4 = _G["MultiBarRightButton"..i]
			bu4:SetAlpha(0)
			bu4:HookScript("OnEnter", function(self) rightlighton(1) end)
			bu4:HookScript("OnLeave", function(self) rightlighton(0) end)
		end

		local bu5 = _G["MultiBarLeftButton"..i]
		bu5:SetAlpha(0)
		bu5:HookScript("OnEnter", function(self) rightlighton(1) end)
		bu5:HookScript("OnLeave", function(self) rightlighton(0) end)
	end
end

----------------------------------------------------------------------------------------
-- Petbar
----------------------------------------------------------------------------------------

local petnum = NUM_PET_ACTION_SLOTS

AnchorPetBar:SetWidth(tDB["cfgBars"]["buPetSize"]*petnum+tDB["cfgBars"]["buOffset"]*(petnum-1))
AnchorPetBar:SetHeight(tDB["cfgBars"]["buPetSize"])

local fbarpet = CreateFrame("Frame","rABS_PetBar",UIParent, "SecureHandlerStateTemplate")
fbarpet:SetWidth(tDB["cfgBars"]["buPetSize"]*petnum+tDB["cfgBars"]["buOffset"]*(petnum-1))
fbarpet:SetHeight(tDB["cfgBars"]["buPetSize"])
fbarpet:SetPoint("TOPLEFT", AnchorPetBar)
fbarpet:SetScale(1)
PetActionBarFrame:SetParent(fbarpet)
PetActionBarFrame:EnableMouse(false)

for i=1, petnum do
	local petbu = _G["PetActionButton"..i]
	local cd = _G["PetActionButton"..i.."Cooldown"]
	petbu:SetSize(tDB["cfgBars"]["buPetSize"], tDB["cfgBars"]["buPetSize"])
	petbu:ClearAllPoints()
	if i == 1 then
		petbu:SetPoint("TOPLEFT", fbarpet, 0,0)
	else
		local previous = _G["PetActionButton"..i-1]
		petbu:SetPoint("LEFT", previous, "RIGHT", tDB["cfgBars"]["buOffset"], 0)
	end
	cd:SetAllPoints(petbu)
end

if tDB["cfgBars"]["mousePet"] then
	local function lighton(alpha)
		if PetActionBarFrame:IsShown() then
			for i=1, petnum do
				local petbu = _G["PetActionButton"..i]
				petbu:SetAlpha(alpha)
			end
		end
	end

	fbarpet:EnableMouse(true)
	fbarpet:SetScript("OnEnter", function(self) lighton(1) end)
	fbarpet:SetScript("OnLeave", function(self) lighton(0) end)
	for i=1, petnum do
		local petbu = _G["PetActionButton"..i]
		petbu:SetAlpha(0)
		petbu:HookScript("OnEnter", function(self) lighton(1) end)
		petbu:HookScript("OnLeave", function(self) lighton(0) end)
	end
end

----------------------------------------------------------------------------------------
-- Shapeshift bar
----------------------------------------------------------------------------------------

if tDB["cfgBars"]["verticalstance"] then
	AnchorStance:SetWidth(tDB["cfgBars"]["buStanceSize"])
	AnchorStance:SetHeight(tDB["cfgBars"]["buStanceSize"]*5+tDB["cfgBars"]["buOffset"]*4)
else
	AnchorStance:SetWidth(tDB["cfgBars"]["buStanceSize"]*5+tDB["cfgBars"]["buOffset"]*4)
	AnchorStance:SetHeight(tDB["cfgBars"]["buStanceSize"])
end

local classbar = CreateFrame("Frame","rABS_StanceBar",UIParent, "SecureHandlerStateTemplate")
classbar:SetAllPoints(AnchorStance)
classbar:SetScale(1)

ShapeshiftBarFrame:SetParent(classbar)
ShapeshiftBarFrame:EnableMouse(false)

for i=1, NUM_SHAPESHIFT_SLOTS do
	local classbu = _G["ShapeshiftButton"..i]
	classbu:SetSize(tDB["cfgBars"]["buStanceSize"], tDB["cfgBars"]["buStanceSize"])
	classbu:ClearAllPoints()
	if i == 1 then
		classbu:SetPoint("BOTTOMLEFT", classbar, 0,0)
	else
		local previous = _G["ShapeshiftButton"..i-1]
		if tDB["cfgBars"]["verticalstance"] then
			classbu:SetPoint("BOTTOM", previous, "TOP", 0, tDB["cfgBars"]["buOffset"])
		else
			classbu:SetPoint("LEFT", previous, "RIGHT", tDB["cfgBars"]["buOffset"], 0)
		end
	end
end

local function MoveShapeshift()
	ShapeshiftButton1:SetPoint("BOTTOMLEFT", classbar, 0,0)
end
hooksecurefunc("ShapeshiftBar_Update", MoveShapeshift);

if tDB["cfgBars"]["mouseStance"] then
	local function lighton(alpha)
		if ShapeshiftBarFrame:IsShown() then
			for i=1, NUM_SHAPESHIFT_SLOTS do
				local classbu = _G["ShapeshiftButton"..i]
				classbu:SetAlpha(alpha)
			end
		end
	end

	classbar:EnableMouse(true)
	classbar:SetScript("OnEnter", function(self) lighton(1) end)
	classbar:SetScript("OnLeave", function(self) lighton(0) end)
	for i=1, NUM_SHAPESHIFT_SLOTS do
		local classbu = _G["ShapeshiftButton"..i]
		classbu:SetAlpha(0)
		classbu:HookScript("OnEnter", function(self) lighton(1) end)
		classbu:HookScript("OnLeave", function(self) lighton(0) end)
	end
end

----------------------------------------------------------------------------------------
-- Totem bar
----------------------------------------------------------------------------------------

if tDB["playerclass"] == "SHAMAN" then
	local tbar = _G['MultiCastActionBarFrame']

	if tbar then
		AnchorTotem:SetWidth(tbar:GetWidth())
		AnchorTotem:SetHeight(tbar:GetHeight())

		tbar:SetParent(AnchorTotem)
		tbar:SetAllPoints(AnchorTotem)

		local function moveTotem(self,a1,af,a2,x,y,...)
		if x ~= -1 then
		  --print('doing')
		  tbar:SetAllPoints(AnchorTotem)
		  tbar:SetFrameStrata("LOW")
		end
		end

		hooksecurefunc(tbar, "SetPoint", moveTotem)

		AnchorTotem:SetScale(0.8)

		tbar:SetMovable(true)
		tbar:SetUserPlaced(true)
		tbar:EnableMouse(false)
	end
end

----------------------------------------------------------------------------------------
-- Vehicle Exit
----------------------------------------------------------------------------------------

local fbarveb = CreateFrame("Frame","rABS_VehicleExit",UIParent, "SecureHandlerStateTemplate")
fbarveb:SetHeight(tDB["cfgBars"]["buStanceSize"])
fbarveb:SetWidth(tDB["cfgBars"]["buStanceSize"])
fbarveb:SetPoint("TOPLEFT", AnchorVehicle)

fbarveb:SetScale(1)

local veb = CreateFrame("BUTTON", nil, fbarveb, "SecureActionButtonTemplate");
veb:SetAllPoints(fbarveb)
veb:RegisterForClicks("AnyUp")
veb:SetNormalTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up")
veb:SetPushedTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
veb:SetHighlightTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down")
veb:SetScript("OnClick", function(self) VehicleExit() end)
veb:RegisterEvent("UNIT_ENTERING_VEHICLE")
veb:RegisterEvent("UNIT_ENTERED_VEHICLE")
veb:RegisterEvent("UNIT_EXITING_VEHICLE")
veb:RegisterEvent("UNIT_EXITED_VEHICLE")
veb:SetScript("OnEvent", function(self,event,...)
local arg1 = ...;
	if(((event=="UNIT_ENTERING_VEHICLE") or (event=="UNIT_ENTERED_VEHICLE")) and arg1 == "player") then
		veb:SetAlpha(1)
	elseif(((event=="UNIT_EXITING_VEHICLE") or (event=="UNIT_EXITED_VEHICLE")) and arg1 == "player") then
		veb:SetAlpha(0)
	end
end)
veb:SetAlpha(0)

----------------------------------------------------------------------------------------
-- BarStyler
----------------------------------------------------------------------------------------

local _G = _G

--initial style func
local function rActionButtonStyler_AB_style(self)
	if not self.rABS_Styled and self:GetParent() and  self:GetParent():GetName() ~= "MultiCastActionBarFrame" and self:GetParent():GetName() ~= "MultiCastActionPage1" and self:GetParent():GetName() ~= "MultiCastActionPage2" and self:GetParent():GetName() ~= "MultiCastActionPage3" then

		local action = self.action
		local name = self:GetName()
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local co  = _G[name.."Count"]
		local bo  = _G[name.."Border"]
		local ho  = _G[name.."HotKey"]
		local cd  = _G[name.."Cooldown"]
		local na  = _G[name.."Name"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture"]

		bo:Hide()
		bo.Show = fpDummy
		na:Hide()

		if not tDB["cfgBars"]["hideHotkey"] then
			ho:SetFont(tDB["cfgBars"]["font"], tDB["cfgBars"]["fontSize"], "OUTLINE")
			ho:ClearAllPoints()
			ho:SetPoint("TOPRIGHT", 1, -1)
			ho:SetWidth(tDB["cfgBars"]["buSize"]+2)
			ho:SetHeight(tDB["cfgBars"]["fontSize"])
		else
			ho:Hide()
			ho.Show = fpDummy
		end

		co:ClearAllPoints()
		co:SetPoint("BOTTOMRIGHT", 0, 2)
		co:SetFont(tDB["cfgBars"]["font"], tDB["cfgBars"]["fontSize"], "OUTLINE")

		--applying the textures
		fl:SetTexture("")
		bu:SetNormalTexture("")

		local hover = self:CreateTexture("frame", nil, self) -- hover
		hover:SetTexture(1,1,1,0.3)
		hover:SetHeight(bu:GetHeight())
		hover:SetWidth(bu:GetWidth())
		hover:SetPoint("TOPLEFT",bu,1,-1)
		hover:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetHighlightTexture(hover)

		local pushed = self:CreateTexture("frame", nil, self) -- pushed
		pushed:SetTexture(0.9,0.8,0.1,0.3)
		pushed:SetHeight(bu:GetHeight())
		pushed:SetWidth(bu:GetWidth())
		pushed:SetPoint("TOPLEFT",bu,1,-1)
		pushed:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetPushedTexture(pushed)

		local checked = self:CreateTexture("frame", nil, self) -- checked
		checked:SetTexture(0.9, 1, 0.2)
		checked:SetHeight(bu:GetHeight())
		checked:SetWidth(bu:GetWidth())
		checked:SetPoint("TOPLEFT",bu,1,-1)
		checked:SetPoint("BOTTOMRIGHT",bu,-1,1)
		checked:SetAlpha(0.3)
		bu:SetCheckedTexture(checked)

		ic:SetTexCoord(0.1,0.9,0.1,0.9)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		--adjust the cooldown frame
		cd:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		if not bu.bg then
			bu.bg = CreateFrame("Frame", nil, bu)
			bu.bg:SetAllPoints()
			SetTemplate(bu.bg)
			bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
		end

		--disable resetting of textures
		fl.SetTexture = fpDummy
		bu.SetHighlightTexture = fpDummy
		bu.SetPushedTexture = fpDummy
		bu.SetCheckedTexture = fpDummy
		bu.SetNormalTexture = fpDummy

		self.rABS_Styled = true
	end
end

  --style pet buttons
local function rActionButtonStyler_AB_stylepet()

	for i=1, NUM_PET_ACTION_SLOTS do
		local name = "PetActionButton"..i
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture2"]
		local cd  = _G[name.."Cooldown"]
		local ac  = _G[name.."AutoCastable"]
		local sh  = _G[name.."Shine"]

		fl:SetTexture("")
		bu:SetNormalTexture("")

		local hover = bu:CreateTexture("frame", nil, self) -- hover
		hover:SetTexture(1,1,1,0.3)
		hover:SetHeight(bu:GetHeight())
		hover:SetWidth(bu:GetWidth())
		hover:SetPoint("TOPLEFT",bu,1,-1)
		hover:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetHighlightTexture(hover)

		local pushed = bu:CreateTexture("frame", nil, self) -- pushed
		pushed:SetTexture(0.9,0.8,0.1,0.3)
		pushed:SetHeight(bu:GetHeight())
		pushed:SetWidth(bu:GetWidth())
		pushed:SetPoint("TOPLEFT",bu,1,-1)
		pushed:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetPushedTexture(pushed)

		local checked = bu:CreateTexture("frame", nil, self) -- checked
		checked:SetTexture(0.9, 1, 0.2)
		checked:SetHeight(bu:GetHeight())
		checked:SetWidth(bu:GetWidth())
		checked:SetPoint("TOPLEFT",bu,1,-1)
		checked:SetPoint("BOTTOMRIGHT",bu,-1,1)
		checked:SetAlpha(0.3)
		bu:SetCheckedTexture(checked)

		--adjust the autocast border
		ac:SetWidth(tDB["cfgBars"]["buPetSize"]*2)
		ac:SetHeight(tDB["cfgBars"]["buPetSize"]*2)
		ac:ClearAllPoints()
		ac:SetPoint("CENTER", bu, 0, 0)

		sh:SetWidth(tDB["cfgBars"]["buPetSize"])
		sh:SetHeight(tDB["cfgBars"]["buPetSize"])
		sh:ClearAllPoints()
		sh:SetPoint("CENTER", bu, 0, 0)

		--cut the default border of the icons and make them shiny
		ic:SetTexCoord(0.1,0.9,0.1,0.9)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		--adjust the cooldown frame
		cd:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		--shadows+background
		if not bu.bg then
			bu.bg = CreateFrame("Frame", nil, bu)
			bu.bg:SetAllPoints()
			SetTemplate(bu.bg, "background")
			bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
		end
	end
end

  --style shapeshift buttons
local function rActionButtonStyler_AB_styleshapeshift()
	for i=1, NUM_SHAPESHIFT_SLOTS do
		local name = "ShapeshiftButton"..i
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture2"]
		local cd  = _G[name.."Cooldown"]

		fl:SetTexture("")
		bu:SetNormalTexture("")

		local hover = bu:CreateTexture("frame", nil, self) -- hover
		hover:SetTexture(1,1,1,0.3)
		hover:SetHeight(bu:GetHeight())
		hover:SetWidth(bu:GetWidth())
		hover:SetPoint("TOPLEFT",bu,1,-1)
		hover:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetHighlightTexture(hover)

		local pushed = bu:CreateTexture("frame", nil, self) -- pushed
		pushed:SetTexture(0.9,0.8,0.1,0.3)
		pushed:SetHeight(bu:GetHeight())
		pushed:SetWidth(bu:GetWidth())
		pushed:SetPoint("TOPLEFT",bu,1,-1)
		pushed:SetPoint("BOTTOMRIGHT",bu,-1,1)
		bu:SetPushedTexture(pushed)

		local checked = bu:CreateTexture("frame", nil, self) -- checked
		checked:SetTexture(0.9, 1, 0.2)
		checked:SetHeight(bu:GetHeight())
		checked:SetWidth(bu:GetWidth())
		checked:SetPoint("TOPLEFT",bu,1,-1)
		checked:SetPoint("BOTTOMRIGHT",bu,-1,1)
		checked:SetAlpha(0.3)
		bu:SetCheckedTexture(checked)

		--cut the default border of the icons and make them shiny
		ic:SetTexCoord(0.1,0.9,0.1,0.9)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		--adjust the cooldown frame
		cd:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		--shadows+background
		if not bu.bg then
			bu.bg = CreateFrame("Frame", nil, bu)
			bu.bg:SetAllPoints()
			SetTemplate(bu.bg, "background")
			bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
		end
	end
end
--[[
local function modActionButton_UpdateHotkeys(self, actionButtonType)
	local hotkey = _G[self:GetName() .. 'HotKey']

	if tDB["cfgBars"]["hideHotkey"] ~= true then
		hotkey:ClearAllPoints()
		hotkey:SetPoint("TOPRIGHT", 1, -1)
		hotkey:SetWidth(tDB["cfgBars"]["buSize"]+2)
		hotkey:SetHeight(tDB["cfgBars"]["fontSize"])
	else
		hotkey:Hide()
	end
end
]]

local buttons = 0
local function rActionButtonStyler_AB_setupflyoutbutton()
	for i=1, buttons do
		--prevent error if you don't have max ammount of buttons
		if _G["SpellFlyoutButton"..i] then
		local but = _G["SpellFlyoutButton"..i]
			if not but.rABS_Styled then
				local name = _G["SpellFlyoutButton"..i]:GetName()
				local bu  = _G[name]
				local ic  = _G[name.."Icon"]
				local co  = _G[name.."Count"]
				local bo  = _G[name.."Border"]
				local ho  = _G[name.."HotKey"]
				local cd  = _G[name.."Cooldown"]
				local na  = _G[name.."Name"]
				local fl  = _G[name.."Flash"]
				local nt  = _G[name.."NormalTexture"]

				bo:Hide()
				bo.Show = fpDummy
				na:Hide()

				if not tDB["cfgBars"]["hideHotkey"] then
					ho:SetFont(tDB["cfgBars"]["font"], tDB["cfgBars"]["fontSize"], "OUTLINE")
					ho:ClearAllPoints()
					ho:SetPoint("TOPRIGHT", 1, -1)
					ho:SetWidth(tDB["cfgBars"]["buSize"]+2)
					ho:SetHeight(tDB["cfgBars"]["fontSize"])
				else
					ho:Hide()
					ho.Show = fpDummy
				end

				co:ClearAllPoints()
				co:SetPoint("BOTTOMRIGHT", 0, 2)
				co:SetFont(tDB["cfgBars"]["font"], tDB["cfgBars"]["fontSize"], "OUTLINE")

				--applying the textures
				fl:SetTexture("")
				bu:SetNormalTexture("")

				local hover = but:CreateTexture("frame", nil, but) -- hover
				hover:SetTexture(1,1,1,0.3)
				hover:SetHeight(bu:GetHeight())
				hover:SetWidth(bu:GetWidth())
				hover:SetPoint("TOPLEFT",bu,1,-1)
				hover:SetPoint("BOTTOMRIGHT",bu,-1,1)
				bu:SetHighlightTexture(hover)

				local pushed = but:CreateTexture("frame", nil, but) -- pushed
				pushed:SetTexture(0.9,0.8,0.1,0.3)
				pushed:SetHeight(bu:GetHeight())
				pushed:SetWidth(bu:GetWidth())
				pushed:SetPoint("TOPLEFT",bu,1,-1)
				pushed:SetPoint("BOTTOMRIGHT",bu,-1,1)
				bu:SetPushedTexture(pushed)

				local checked = but:CreateTexture("frame", nil, but) -- checked
				checked:SetTexture(0.9, 1, 0.2)
				checked:SetHeight(bu:GetHeight())
				checked:SetWidth(bu:GetWidth())
				checked:SetPoint("TOPLEFT",bu,1,-1)
				checked:SetPoint("BOTTOMRIGHT",bu,-1,1)
				checked:SetAlpha(0.3)
				bu:SetCheckedTexture(checked)

				ic:SetTexCoord(0.1,0.9,0.1,0.9)
				ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
				ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

				--adjust the cooldown frame
				cd:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
				cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

				if not bu.bg then
					bu.bg = CreateFrame("Frame", nil, bu)
					bu.bg:SetAllPoints()
					SetTemplate(bu.bg, "bushadow")
					bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
				end

				--disable resetting of textures
				fl.SetTexture = fpDummy
				bu.SetHighlightTexture = fpDummy
				bu.SetPushedTexture = fpDummy
				bu.SetCheckedTexture = fpDummy
				bu.SetNormalTexture = fpDummy

				but.rABS_Styled = true	
			end		
		
			if tDB["cfgBars"]["mouseRight"] then
				SpellFlyout:HookScript("OnEnter", function(self) rightlighton(1) end)
				SpellFlyout:HookScript("OnLeave", function(self) rightlighton(0) end)
				_G["SpellFlyoutButton"..i]:HookScript("OnEnter", function(self) rightlighton(1) end)
				_G["SpellFlyoutButton"..i]:HookScript("OnLeave", function(self) rightlighton(0) end)
			end
		end
	end
end
SpellFlyout:HookScript("OnShow", rActionButtonStyler_AB_setupflyoutbutton)

local function rActionButtonStyler_AB_styleflyout(self)
	self.FlyoutBorder:SetAlpha(0)
	self.FlyoutBorderShadow:SetAlpha(0)

	SpellFlyoutHorizontalBackground:SetAlpha(0)
	SpellFlyoutVerticalBackground:SetAlpha(0)
	SpellFlyoutBackgroundEnd:SetAlpha(0)

	for i=1, GetNumFlyouts() do
		local x = GetFlyoutID(i)
		local _, _, numSlots, isKnown = GetFlyoutInfo(x)
		if isKnown then
			buttons = numSlots
			break
		end
	end
end

---------------------------------------
-- CALLS // HOOKS
---------------------------------------

hooksecurefunc("ActionButton_Update",         rActionButtonStyler_AB_style)
hooksecurefunc("ShapeshiftBar_Update",        rActionButtonStyler_AB_styleshapeshift)
hooksecurefunc("ShapeshiftBar_UpdateState",   rActionButtonStyler_AB_styleshapeshift)
hooksecurefunc("PetActionBar_Update",         rActionButtonStyler_AB_stylepet)
hooksecurefunc("ActionButton_UpdateFlyout",   rActionButtonStyler_AB_styleflyout)
--hooksecurefunc("ActionButton_UpdateHotkeys",  modActionButton_UpdateHotkeys)

end
tinsert(ThunderUI.modules, module)