﻿AnchorBuffs = CreateFrame("Frame","Move_Buffs",UIParent)
AnchorBuffs:SetPoint("TOPRIGHT", -15, -15)
CreateAnchor(AnchorBuffs, "Move buffs", 200, 30)

AnchorDebuffs = CreateFrame("Frame","Move_Debuffs",UIParent)
AnchorDebuffs:SetPoint("TOPRIGHT", -15, -119)
CreateAnchor(AnchorDebuffs, "Move debuffs", 200, 30)

local module = {}
module.name = "cfgBuffs"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB

----------------------------------------------------------------------------------------
-- monoBuffs
-- MonoLIT - 2010
----------------------------------------------------------------------------------------

BUFFS_PER_ROW = tDB["cfgBuffs"]["perRow"]
local mh, _, _, oh, _, _, te = GetWeaponEnchantInfo()

ConsolidatedBuffs:ClearAllPoints()
ConsolidatedBuffs:SetPoint("TOPRIGHT", AnchorBuffs)
ConsolidatedBuffs:SetSize(tDB["cfgBuffs"]["buffsSize"], tDB["cfgBuffs"]["buffsSize"])
ConsolidatedBuffs.SetPoint = function() end
ConsolidatedBuffsIcon:SetTexture("Interface\\Icons\\Spell_ChargePositive")
ConsolidatedBuffsIcon:SetTexCoord(0.03,0.97,0.03,0.97)
ConsolidatedBuffsIcon:SetSize(tDB["cfgBuffs"]["buffsSize"]-2,tDB["cfgBuffs"]["buffsSize"]-2)
local h = CreateFrame("Frame")
h:SetParent(ConsolidatedBuffs)
h:SetAllPoints(ConsolidatedBuffs)
h:SetFrameLevel(30)
ConsolidatedBuffsCount:SetParent(h)
ConsolidatedBuffsCount:SetPoint("BOTTOMRIGHT")
ConsolidatedBuffsCount:SetFont(tDB["cfgBuffs"]["font"], tDB["cfgBuffs"]["fontSize"], "OUTLINE")
local CBbg = CreateFrame("Frame", nil, ConsolidatedBuffs)

for i = 1, 3 do
	_G["TempEnchant"..i.."Border"]:Hide()
	local te 			= _G["TempEnchant"..i]
	local teicon 		= _G["TempEnchant"..i.."Icon"]
	local teduration 	= _G["TempEnchant"..i.."Duration"]
	local h = CreateFrame("Frame")
	h:SetParent(te)
	h:SetAllPoints(te)
	h:SetFrameLevel(30)
	te:SetSize(tDB["cfgBuffs"]["buffsSize"],tDB["cfgBuffs"]["buffsSize"])
	teicon:SetPoint("BOTTOMRIGHT", te, -1, 1)
	teicon:SetTexCoord(.08, .92, .08, .92)
	teicon:SetPoint("TOPLEFT", te, 1, -1)
	teduration:ClearAllPoints()
	teduration:SetParent(h)
	teduration:SetPoint("BOTTOM", 0, tDB["cfgBuffs"]["timeYoffset"])
	teduration:SetFont(tDB["cfgBuffs"]["font"], tDB["cfgBuffs"]["fontSize"], "THINOUTLINE")
	local bd = CreateFrame("Frame", i.."tePanel", te)
	bd:SetPoint("TOPLEFT", 0, 0)
	bd:SetPoint("BOTTOMRIGHT", 0, 0)
	SetTemplate(bd, "bushadow")
	te.bd = bd
	local bg = CreateFrame("Frame", nil, te)
end

local function CreateBuffStyle(buttonName, i, debuff)
	local buff		= _G[buttonName..i]
	local icon		= _G[buttonName..i.."Icon"]
	local border	= _G[buttonName..i.."Border"]
	local duration	= _G[buttonName..i.."Duration"]
	local count 	= _G[buttonName..i.."Count"]

	if icon and not _G[buttonName..i.."Background"] then
		icon:SetTexCoord(.08, .92, .08, .92)
		icon:SetPoint("TOPLEFT", buff, 1, -1)
		icon:SetPoint("BOTTOMRIGHT", buff, -1, 1)
		if debuff then
			buff:SetSize(tDB["cfgBuffs"]["debuffsSize"],tDB["cfgBuffs"]["debuffsSize"])
		else
			buff:SetSize(tDB["cfgBuffs"]["buffsSize"],tDB["cfgBuffs"]["buffsSize"])
		end
		duration:ClearAllPoints()
		duration:SetPoint("BOTTOM", 1, tDB["cfgBuffs"]["timeYoffset"])
		duration:SetFont(tDB["cfgBuffs"]["font"], tDB["cfgBuffs"]["fontSize"], "THINOUTLINE")
		local bg = CreateFrame("Frame", buttonName..i.."Background", buff)
		count:ClearAllPoints()
		count:SetPoint("TOPRIGHT", buff, -1, -1)
		count:SetFont(tDB["cfgBuffs"]["font"], tDB["cfgBuffs"]["fontSize"], "OUTLINE")
		
		local bd = CreateFrame("Frame", buttonName..i.."Panel", buff)
		bd:SetPoint("TOPLEFT", 0, 0)
		bd:SetPoint("BOTTOMRIGHT", 0, 0)
		SetTemplate(bd, "bushadow")
		buff.bd = bd
		
		if debuff then
			buff.bd:SetBackdropBorderColor(0.7,.3,.3,1)
		else
			buff.bd:SetBackdropBorderColor(unpack(tDB["cfgMedia"]["colorBR"])) 
		end
			
	end
	if border then border:Hide() end
end

local function OverrideBuffAnchors()
	local buttonName = "BuffButton" -- c
	local buff, previousBuff, aboveBuff;
	local numBuffs = 0;
	local slack = BuffFrame.numEnchants
	local mh, _, _, oh, _, _, te = GetWeaponEnchantInfo()
	if ( BuffFrame.numConsolidated > 0 ) then
		slack = slack + 1;	
	end
	for i=1, BUFF_ACTUAL_DISPLAY do
		CreateBuffStyle(buttonName, i, false)
		local buff = _G[buttonName..i]
		if not ( buff.consolidated ) then	
			numBuffs = numBuffs + 1
			i = numBuffs + slack
			buff:ClearAllPoints()
			if ( (i > 1) and (mod(i, BUFFS_PER_ROW) == 1) ) then
 				if ( i == BUFFS_PER_ROW+1 ) then
					buff:SetPoint("TOP", ConsolidatedBuffs, "BOTTOM", 0, -20)
				else
					buff:SetPoint("TOP", aboveBuff, "BOTTOM", 0, -20)
				end
				aboveBuff = buff; 
			elseif ( i == 1 ) then
				buff:SetPoint("TOPRIGHT", AnchorBuffs)
			else
				if ( numBuffs == 1 ) then
					if mh and oh and te and not UnitHasVehicleUI("player") then
						buff:SetPoint("TOPRIGHT", TempEnchant3, "TOPLEFT", -tDB["cfgBuffs"]["buffsOffset"], 0);
					elseif ((mh and oh and not te) or (mh and te and not oh) or (te and oh and not mh)) and not UnitHasVehicleUI("player") then
						buff:SetPoint("TOPRIGHT", TempEnchant2, "TOPLEFT", -tDB["cfgBuffs"]["buffsOffset"], 0);
					elseif ((mh and not oh and not te) or (oh and not te and not mh) or (te and not oh and not mh)) and not UnitHasVehicleUI("player") then
						buff:SetPoint("TOPRIGHT", TempEnchant1, "TOPLEFT", -tDB["cfgBuffs"]["buffsOffset"], 0)
					else
						buff:SetPoint("TOPRIGHT", ConsolidatedBuffs, "TOPLEFT", -tDB["cfgBuffs"]["buffsOffset"], 0);
					end
				else
					buff:SetPoint("RIGHT", previousBuff, "LEFT", -tDB["cfgBuffs"]["buffsOffset"], 0);
				end
			end
			previousBuff = buff
		end		
	end
end

local function OverrideDebuffAnchors(buttonName, i)
	if tDB["cfgBuffs"]["showDebuffs"] then
		CreateBuffStyle(buttonName, i, true)
		local debuff = _G[buttonName..i];
		local dtype = select(5, UnitDebuff("player",i))      
		local color
		if (dtype ~= nil) then
			color = DebuffTypeColor[dtype]
		else
			color = DebuffTypeColor["none"]
		end
		debuff:ClearAllPoints()
		if i == 1 then
			debuff:SetPoint("TOPRIGHT", AnchorDebuffs)
		else
			debuff:SetPoint("RIGHT", _G[buttonName..(i-1)], "LEFT", -tDB["cfgBuffs"]["buffsOffset"], 0)
		end
	else
		_G[buttonName..i]:Hide()
	end
end

-- fixing the consolidated buff container sizes because the default formula is just SHIT!
local z = 0.79 -- 37 : 28 // 30 : 24 -- dasdas;djal;fkjl;jkfsfoi !!!! meaningfull comments we all love them!!11
local function OverrideConsolidatedBuffsAnchors()
	ConsolidatedBuffsTooltip:SetWidth(min(BuffFrame.numConsolidated * tDB["cfgBuffs"]["buffsSize"] * z + 18, 4 * tDB["cfgBuffs"]["buffsSize"] * z + 18));
    ConsolidatedBuffsTooltip:SetHeight(floor((BuffFrame.numConsolidated + 3) / 4 ) * tDB["cfgBuffs"]["buffsSize"] * z + CONSOLIDATED_BUFF_ROW_HEIGHT * z);
end

hooksecurefunc("BuffFrame_UpdateAllBuffAnchors", OverrideBuffAnchors)
hooksecurefunc("DebuffButton_UpdateAnchors", OverrideDebuffAnchors)
--hooksecurefunc("AuraButton_Update", OverrideAuraButton_Update)
hooksecurefunc("ConsolidatedBuffs_UpdateAllAnchors", OverrideConsolidatedBuffsAnchors)


end
tinsert(ThunderUI.modules, module)