﻿AnchorWatchFrame = CreateFrame("Frame","Move_WatchFrame",UIParent)
AnchorWatchFrame:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -150, -210)
CreateAnchor(AnchorWatchFrame, "Move watch frame", 160, 20)

AnchorUpFrame = CreateFrame("Frame","Move_UpFrame",UIParent)
AnchorUpFrame:SetPoint("TOP", UIParent, "TOP", 0, -50)
CreateAnchor(AnchorUpFrame, "Move up data frame", 160, 20)

AnchorCaptureBar = CreateFrame("Frame","Move_CaptureBar",UIParent)
AnchorCaptureBar:SetPoint("TOP", UIParent, "TOP", 0, -120)
CreateAnchor(AnchorCaptureBar, "Move capture bar", 160, 20)

local module = {}
module.name = "cfgTweaker"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB

----------------------------------------------------------------------------------------
-- aSettings 
-- by ALZA - 2010
----------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------
-- Quest tracker
----------------------------------------------------------------------------------------

WatchFrame:SetClampedToScreen(false)
WatchFrame:ClearAllPoints()
WatchFrame.ClearAllPoints = fpDummy
WatchFrame:SetWidth(250)
WatchFrame:SetHeight(500)
WatchFrame:SetPoint("TOPRIGHT", AnchorWatchFrame)
WatchFrame.SetPoint = fpDummy

----------------------------------------------------------------------------------------
-- Clear UIErrors frame(ncError by Nightcracker)
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["hideErrors"] then
	local f, o, ncErrorDB = CreateFrame("Frame"), "No error yet.", {
	["Inventory is full."] = true,
	["Your quest log is full"] = true,
	["Нет места."] = true,
	["У вас слишком много таких предметов."] = true,
	["У вас недостаточно денег."] = true,
	["Предмет не найден."] = true,
	}
	f:SetScript("OnEvent", function(self, event, error)
		if ncErrorDB[error] then
			UIErrorsFrame:AddMessage(error, 1, 0, 0)
		else
			o = error
		end
	end)
	SLASH_NCERROR1 = "/error"
	function SlashCmdList.NCERROR() print(o) end
	UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
	f:RegisterEvent("UI_ERROR_MESSAGE")
end

----------------------------------------------------------------------------------------
-- Auto decline duels
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["declineDuels"] then
	local dd = CreateFrame("Frame")
	dd:RegisterEvent("DUEL_REQUESTED")
	dd:SetScript("OnEvent", function(self, event, name)
		HideUIPanel(StaticPopup1)
		CancelDuel()
		print(format("|cff00ffffDeclined duel request from: "..name))
	end)
end

----------------------------------------------------------------------------------------
-- Auto Accept Invites
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["acceptGroup"] then
	local IsFriend = function(name)
		for i = 1, GetNumFriends() do if(GetFriendInfo(i) == name) then return true end end
		if(IsInGuild()) then for i = 1, GetNumGuildMembers() do if(GetGuildRosterInfo(i) == name) then return true end end end
	end

	local ai = CreateFrame("Frame")
	ai:RegisterEvent("PARTY_INVITE_REQUEST")
	ai:SetScript("OnEvent", function(frame, event, name)
		if(IsFriend(name)) then
			if MiniMapLFGFrame:IsShown() then return end -- Prevent losing LFD
			print(format("|cffffff00Accepted invite from: "..name.."."))
			AcceptGroup()
			for i = 1, 4 do
				local frame = _G["StaticPopup"..i]
				if(frame:IsVisible() and frame.which == "PARTY_INVITE") then
					frame.inviteAccepted = 1
					StaticPopup_Hide("PARTY_INVITE")
					return
				end
			end
		else
			SendWho(name)
		end
	end)
end

----------------------------------------------------------------------------------------
--	Grab mail in 1 button(OpenAll by Kemayo)
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["grabMail"] then

if (IsAddOnLoaded("QuickAuctions") or IsAddOnLoaded("OpenAll")) then return end

local deletedelay, t = 0.5, 0
local takingOnlyCash = false
local button, button2, waitForMail, doNothing, openAll, openAllCash, openMail, lastopened, stopOpening, onEvent, needsToWait, copper_to_pretty_money, total_cash
local _G = _G
local baseInboxFrame_OnClick
function doNothing() end

function openAll()
	if GetInboxNumItems() == 0 then return end
	button:SetScript("OnClick", nil)
	button2:SetScript("OnClick", nil)
	baseInboxFrame_OnClick = InboxFrame_OnClick
	InboxFrame_OnClick = doNothing
	button:RegisterEvent("UI_ERROR_MESSAGE")
	openMail(GetInboxNumItems())
end

function openAllCash()
	takingOnlyCash = true
	openAll()
end

function openMail(index)
	if not InboxFrame:IsVisible() then return stopOpening("|cffffff00Need a mailbox.") end
	if index == 0 then MiniMapMailFrame:Hide() stopOpening("|cffffff00All done.") return end
	local _, _, _, _, money, COD, _, numItems = GetInboxHeaderInfo(index)
	if money > 0 then
		TakeInboxMoney(index)
		needsToWait = true
		if total_cash then total_cash = total_cash - money end
	elseif (not takingOnlyCash) and numItems and (numItems > 0) and COD <= 0 then
		TakeInboxItem(index)
		needsToWait = true
	end
	local items = GetInboxNumItems()
	if (numItems and numItems > 1) or (items > 1 and index <= items) then
		lastopened = index
		t = 0
		button:SetScript("OnUpdate", waitForMail)
	else
		stopOpening("|cffffff00All done.")
		MiniMapMailFrame:Hide()
	end
end

function waitForMail(self, elapsed)
	t = t + elapsed
	if (not needsToWait) or (t > deletedelay) then
		needsToWait = false
		button:SetScript("OnUpdate", nil)
		local _, _, _, _, money, COD, _, numItems = GetInboxHeaderInfo(lastopened)
		if money > 0 or ((not takingOnlyCash) and COD <= 0 and numItems and (numItems > 0)) then
			openMail(lastopened)
		else
			openMail(lastopened - 1)
		end
	end
end

function stopOpening(msg, ...)
	button:SetScript("OnUpdate", nil)
	button:SetScript("OnClick", openAll)
	button2:SetScript("OnClick", openAllCash)
	if baseInboxFrame_OnClick then
		InboxFrame_OnClick = baseInboxFrame_OnClick
	end
	button:UnregisterEvent("UI_ERROR_MESSAGE")
	takingOnlyCash = false
	total_cash = nil
	if msg then DEFAULT_CHAT_FRAME:AddMessage(msg, ...) end
end

function onEvent(frame, event, arg1, arg2, arg3, arg4)
	if event == "UI_ERROR_MESSAGE" then
		if arg1 == ERR_INV_FULL then
			stopOpening("|cffffff00Stopped, inventory is full.")
		end
	end
end

local function makeButton(id, text, w, h, x, y)
	local button = CreateFrame("Button", id, InboxFrame, "UIPanelButtonTemplate")
	button:SetWidth(w)
	button:SetHeight(h)
	button:SetPoint("CENTER", InboxFrame, "TOP", x, y)
	button:SetText(text)
	return button
end
button = makeButton("OpenAllButton", "Take All", 70, 25, -45, -408)
button:SetScript("OnClick", openAll)
button:SetScript("OnEvent", onEvent)
button2 = makeButton("OpenAllButton2", "Take Cash", 70, 25, 28, -408)
button2:SetScript("OnClick", openAllCash)

button:SetScript("OnEnter", function()
	GameTooltip:SetOwner(button, "ANCHOR_RIGHT")
	GameTooltip:AddLine(string.format("%d ".."messages", GetInboxNumItems()), 1, 1, 1)
	GameTooltip:Show()
end)
button:SetScript("OnLeave", function() GameTooltip:Hide() end)

function copper_to_pretty_money(c)
	if c > 10000 then
		return ("%d|cffffd700g|r %d|cffc7c7cfs|r %d|cffeda55fc|r"):format(c/10000, (c/100)%100, c%100)
	elseif c > 100 then
		return ("%d|cffc7c7cfs|r %d|cffeda55fc|r"):format((c/100)%100, c%100)
	else
		return ("%d|cffeda55fc|r"):format(c%100)
	end
end

button2:SetScript("OnEnter", function()
	if not total_cash then
		total_cash = 0
		for index=0, GetInboxNumItems() do
			total_cash = total_cash + select(5, GetInboxHeaderInfo(index))
		end
	end
	GameTooltip:SetOwner(button, "ANCHOR_RIGHT")
	GameTooltip:AddLine(copper_to_pretty_money(total_cash), 1, 1, 1)
	GameTooltip:Show()
end)

button2:SetScript("OnLeave", function()	GameTooltip:Hide() end)
end

----------------------------------------------------------------------------------------
-- Mob marking(by ALZA)
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["markMenu"] then
	local menuFrame = CreateFrame("Frame", "aSettingsMarkingFrame", UIParent, "UIDropDownMenuTemplate")
	local menuList = {
		{text = RAID_TARGET_NONE,
		func = function() SetRaidTarget("target", 0) end},
		{text = RAID_TARGET_8,
		func = function() SetRaidTarget("target", 8) end},
		{text = "|cffff0000"..RAID_TARGET_7.."|r",
		func = function() SetRaidTarget("target", 7) end},
		{text = "|cff00ffff"..RAID_TARGET_6.."|r",
		func = function() SetRaidTarget("target", 6) end},
		{text = "|cffC7C7C7"..RAID_TARGET_5.."|r",
		func = function() SetRaidTarget("target", 5) end},
		{text = "|cff00ff00"..RAID_TARGET_4.."|r",
		func = function() SetRaidTarget("target", 4) end},
		{text = "|cff912CEE"..RAID_TARGET_3.."|r",
		func = function() SetRaidTarget("target", 3) end},
		{text = "|cffFF8000"..RAID_TARGET_2.."|r",
		func = function() SetRaidTarget("target", 2) end},
		{text = "|cffffff00"..RAID_TARGET_1.."|r",
		func = function() SetRaidTarget("target", 1) end},
	}

	WorldFrame:HookScript("OnMouseDown", function(self, button)
		if(button=="LeftButton" and IsShiftKeyDown() and UnitExists("mouseover")) then --IsShiftKeyDown() or IsControlKeyDown() or IsAltKeyDown()
			local inParty = (GetNumPartyMembers() > 0)
			local inRaid = (GetNumRaidMembers() > 0)
			if(inRaid and (IsRaidLeader() or IsRaidOfficer()) or (inParty and not inRaid)) then
				EasyMenu(menuList, menuFrame, "cursor", 0, 0, "MENU", 1)
			end
		end
	end)
end

----------------------------------------------------------------------------------------
--	Merchant ( tukui part )
----------------------------------------------------------------------------------------
if tDB["cfgTweaker"]["merchant"] then
	local f = CreateFrame("Frame")
	f:SetScript("OnEvent", function()

		local c = 0
		for b=0,4 do
			for s=1,GetContainerNumSlots(b) do
				local l = GetContainerItemLink(b, s)
				if l then
					local p = select(11, GetItemInfo(l))*select(2, GetContainerItemInfo(b, s))
					if select(3, GetItemInfo(l))==0 then
						UseContainerItem(b, s)
						PickupMerchantItem()
						c = c+p
					end
				end
			end
		end
		if c>0 then
			local g, s, c = math.floor(c/10000) or 0, math.floor((c%10000)/100) or 0, c%100
			DEFAULT_CHAT_FRAME:AddMessage("All trash selled |cffffffff"..g.."g |cffffffff"..s.."s |cffffffff"..c.."c.",255,255,0)
		end

		if not IsShiftKeyDown() then
			if CanMerchantRepair() then
				cost, possible = GetRepairAllCost()
				if cost>0 then
					if possible then
						RepairAllItems()
						local c = cost%100
						local s = math.floor((cost%10000)/100)
						local g = math.floor(cost/10000)
						DEFAULT_CHAT_FRAME:AddMessage("Repair cost: |cffffffff"..g.."g |cffffffff"..s.."s |cffffffff"..c.."c.",255,255,0)
					else
						DEFAULT_CHAT_FRAME:AddMessage("No money for repair",255,0,0)
					end
				end
			end
		end
		
	end)
	f:RegisterEvent("MERCHANT_SHOW")

	-- buy max number value with alt
	local savedMerchantItemButton_OnModifiedClick = MerchantItemButton_OnModifiedClick
	function MerchantItemButton_OnModifiedClick(self, ...)
		if ( IsAltKeyDown() ) then
			local maxStack = select(8, GetItemInfo(GetMerchantItemLink(self:GetID())))
			local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(self:GetID())
			if ( maxStack and maxStack > 1 ) then
				BuyMerchantItem(self:GetID(), floor(maxStack))
			end
		end
		savedMerchantItemButton_OnModifiedClick(self, ...)
	end
end

-------- < Universal Mount macro:  Mountz("your_ground_mount","your_flying_mount") 
function Mountz(groundmount, flyingmount, underwatermount)
    local flyablex, swimablex, vjswim
	local num = GetNumCompanions("MOUNT")
--	local continent = GetCurrentMapContinent()	local zone = GetCurrentMapZone() if zone == 16 and continent == 2 then end
    if not num or IsMounted() then
        Dismount()
        return
    end
    if CanExitVehicle() then 
        VehicleExit()
        return
    end
	for i = 1, 40 do
		local n, _, _, _, _, _, _, _, _, _, sid = UnitBuff("player",i) 
		if sid == 73701 or sid == 76377 then
			vjswim = true
		end
	end
	flyablex = IsFlyableArea()
    if IsControlKeyDown() then
        flyablex = not flyablex
    end
	if IsAltKeyDown() then
        vjswim = not vjswim
    end
    for i=1, num, 1 do
        local _, info, id = GetCompanionInfo("MOUNT", i)
        if flyingmount and info == flyingmount and flyablex then
            CallCompanion("MOUNT", i)
            return
        elseif groundmount and info == groundmount and not flyablex then
            CallCompanion("MOUNT", i)
            return
		elseif id == 75207 and vjswim and IsSwimming() then
			CallCompanion("MOUNT", i)
            return
        end
    end
end

----------------------------------------------------------------------------------------
-- Moving Battlefield score frame and CaptureBar
----------------------------------------------------------------------------------------

if (WorldStateAlwaysUpFrame) then
    WorldStateAlwaysUpFrame:ClearAllPoints()
    WorldStateAlwaysUpFrame:SetPoint("TOP", AnchorUpFrame)
    WorldStateAlwaysUpFrame:SetScale(0.9)
    WorldStateAlwaysUpFrame.SetPoint = fpDummy
end 

local function CaptureUpdate()
	for i = 1, NUM_EXTENDED_UI_FRAMES do
		local cb = _G["WorldStateCaptureBar"..i]
		if cb and cb:IsShown() then
			cb:ClearAllPoints()
			cb:SetPoint("TOP", AnchorCaptureBar)
		end
	end
end
hooksecurefunc("WorldStateAlwaysUpFrame_Update", CaptureUpdate)



----------------------------------------------------------------------------------------
-- Quest level(yQuestLevel by yleaf)
----------------------------------------------------------------------------------------
local function update()
	local buttons = QuestLogScrollFrame.buttons
	local numButtons = #buttons
	local scrollOffset = HybridScrollFrame_GetOffset(QuestLogScrollFrame)
	local numEntries, numQuests = GetNumQuestLogEntries()
	
	for i = 1, numButtons do
		local questIndex = i + scrollOffset
		local questLogTitle = buttons[i]
		if questIndex <= numEntries then
			local title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex)
			if not isHeader then
				questLogTitle:SetText("[" .. level .. "] " .. title)
				QuestLogTitleButton_Resize(questLogTitle)
			end
		end
	end
end

hooksecurefunc("QuestLog_Update", update)
QuestLogScrollFrameScrollBar:HookScript("OnValueChanged", update)

----------------------------------------------------------------------------------------
-- Slash commands
----------------------------------------------------------------------------------------

SlashCmdList["FRAME"] = function(arg)
	if arg ~= "" then
		arg = _G[arg]
	else
		arg = GetMouseFocus()
	end
	if arg ~= nil and arg:GetName() ~= nil then
		local point, relativeTo, relativePoint, xOfs, yOfs = arg:GetPoint()
		ChatFrame1:AddMessage("|cffCC0000----------------------------")
		ChatFrame1:AddMessage("Name: |cffFFD100"..arg:GetName())
		if arg:GetParent() and arg:GetParent():GetName() then
			ChatFrame1:AddMessage("Parent: |cffFFD100"..arg:GetParent():GetName())
		end
 
		ChatFrame1:AddMessage("Width: |cffFFD100"..format("%.2f",arg:GetWidth()))
		ChatFrame1:AddMessage("Height: |cffFFD100"..format("%.2f",arg:GetHeight()))
		ChatFrame1:AddMessage("Strata: |cffFFD100"..arg:GetFrameStrata())
		ChatFrame1:AddMessage("Level: |cffFFD100"..arg:GetFrameLevel())
 
		if xOfs then
			ChatFrame1:AddMessage("X: |cffFFD100"..format("%.2f",xOfs))
		end
		if yOfs then
			ChatFrame1:AddMessage("Y: |cffFFD100"..format("%.2f",yOfs))
		end
		if relativeTo and relativeTo:GetName() then
			ChatFrame1:AddMessage("Point: |cffFFD100"..point.."|r anchored to "..relativeTo:GetName().."'s |cffFFD100"..relativePoint)
		end
		ChatFrame1:AddMessage("|cffCC0000----------------------------")
	elseif arg == nil then
		ChatFrame1:AddMessage("Invalid frame name")
	else
		ChatFrame1:AddMessage("Could not find frame info")
	end
end
SLASH_FRAME1 = "/frame"

SlashCmdList["SC"] = function() print(GetMouseFocus():GetEffectiveScale()) end
SLASH_SK1 = "/sc"

SlashCmdList["GETPARENT"] = function() print(GetMouseFocus():GetParent():GetName()) end
SLASH_GETPARENT1 = "/gp"
SLASH_GETPARENT2 = "/parent"

SlashCmdList["RELOADUI"] = function() ReloadUI() end
SLASH_RELOADUI1 = "/rl"
SLASH_RELOADUI2 = "/кд"

SlashCmdList["RCSLASH"] = function() DoReadyCheck() end
SLASH_RCSLASH1 = "/rc"
SLASH_RCSLASH2 = "/кс"

SlashCmdList["TICKET"] = function() ToggleHelpFrame() end
SLASH_TICKET1 = "/ticket"
SLASH_TICKET2 = "/gm"
SLASH_TICKET3 = "/гм"

SlashCmdList["DISABLE_ADDON"] = function(s) DisableAddOn(s) end
SLASH_DISABLE_ADDON1 = "/dis"

SlashCmdList["ENABLE_ADDON"] = function(s) EnableAddOn(s) end
SLASH_ENABLE_ADDON1 = "/en"

----------------------------------------------------------------------------------------
-- fix the fucking combatlog after a crash (a wow 2.4 and 3.3.2 bug)
----------------------------------------------------------------------------------------

local function CLFIX()
	CombatLogClearEntries()
end

SLASH_CLFIX1 = "/clfix"
SlashCmdList["CLFIX"] = CLFIX

end
tinsert(ThunderUI.modules, module)

local module = {}
module.name = "unitframes"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB
	
end
tinsert(ThunderUI.modules, module)

if not IsAddOnLoaded("Skada") then return end

local module = {}
module.name = "AddonSkin"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB

local Skada = Skada
local barSpacing = 1
local borderWidth = 1

-- Used to strip unecessary options from the in-game config
local function StripOptions(options)
	options.baroptions.args.bartexture = options.windowoptions.args.height
	options.baroptions.args.bartexture.order = 12
	options.baroptions.args.bartexture.max = 1
	options.baroptions.args.barspacing = nil
	options.titleoptions.args.texture = nil
	options.titleoptions.args.bordertexture = nil
	options.titleoptions.args.thickness = nil
	options.titleoptions.args.margin = nil
	options.titleoptions.args.color = nil
	options.windowoptions = nil
	options.baroptions.args.barfont = nil
	options.titleoptions.args.font = nil
end

local barmod = Skada.displays["bar"]
barmod.AddDisplayOptions_ = barmod.AddDisplayOptions
barmod.AddDisplayOptions = function(self, win, options)
	self:AddDisplayOptions_(win, options)
	StripOptions(options)
end

for k, options in pairs(Skada.options.args.windows.args) do
	if options.type == "group" then
		StripOptions(options.args)
	end
end

-- Size height correctly
barmod.AdjustBackgroundHeight = function(self,win)
	local numbars = 0
	if win.bargroup:GetBars() ~= nil then
		if win.db.background.height == 0 then
			for name, bar in pairs(win.bargroup:GetBars()) do if bar:IsShown() then numbars = numbars + 1 end end
		else
			numbars = win.db.barmax
		end
		if win.db.enabletitle then numbars = numbars + 1 end
		if numbars < 1 then numbars = 1 end
		local height = numbars * (win.db.barheight + barSpacing) + barSpacing + borderWidth +2
		if win.bargroup.bgframe:GetHeight() ~= height then
			win.bargroup.bgframe:SetHeight(height)
		end
	end
end

-- Override settings from in-game GUI
local titleBG = {
	bgFile = tDB["cfgMedia"]["textureBar"],
	tile = false,
	tileSize = 0
}

barmod.ApplySettings_ = barmod.ApplySettings
barmod.ApplySettings = function(self, win)
	win.db.enablebackground = true
	win.db.background.borderthickness = borderWidth
	barmod:ApplySettings_(win)

	if win.db.enabletitle then
		win.bargroup.button:SetBackdrop(titleBG)
	end
	
	win.bargroup:SetTexture(tDB["cfgMedia"]["textureBar"])
	win.bargroup:SetSpacing(barSpacing)
	win.bargroup:SetFont(tDB["cfgMedia"]["font"], tDB["cfgMedia"]["fontSize"])
	win.bargroup:SetFrameLevel(5)
	
	local titlefont = CreateFont("TitleFont"..win.db.name)
	titlefont:SetFont(tDB["cfgMedia"]["font"], tDB["cfgMedia"]["fontSize"])
	win.bargroup.button:SetNormalFontObject(titlefont)

	local color = win.db.title.color
	win.bargroup.button:SetBackdropColor(0,0,0,0)
	if win.bargroup.bgframe then
		SetTemplate(win.bargroup.bgframe, "skada", true)
		if win.db.reversegrowth then
			win.bargroup.bgframe:SetPoint("BOTTOM", win.bargroup.button, "BOTTOM", 0, -1 * (win.db.enabletitle and 2 or 1)-2)
		else
			win.bargroup.bgframe:SetPoint("TOP", win.bargroup.button, "TOP", 0,1 * (win.db.enabletitle and 2 or 1)+2)
		end
	end
	
	self:AdjustBackgroundHeight(win)
	win.bargroup:SetMaxBars(win.db.barmax)
	win.bargroup:SortBars()
end

local function EmbedWindow(window, width, height, max, point, relativeFrame, relativePoint, ofsx, ofsy)
	window.db.barwidth = width
	window.db.barheight = height
	window.db.barmax = (floor(max / window.db.barheight) - (window.db.enabletitle and 1 or 0))
	window.db.background.height = 1
	window.db.spark = false
	window.db.barslocked = true
	window.bargroup:ClearAllPoints()
	window.bargroup:SetPoint(point, relativeFrame, relativePoint, ofsx, ofsy)
	
	barmod.ApplySettings(barmod, window)
end

local windows = {}

-- Update pre-existing displays
for _, window in ipairs(Skada:GetWindows()) do
	window:UpdateDisplay()
	tinsert(windows, window)
end

end
tinsert(ThunderUI.modules, module)






