﻿local name, addon = ...

AnchorGrid = CreateFrame("Frame","Move_Grid",UIParent)
AnchorGrid:SetPoint("LEFT", UIParent, "LEFT", 15, 0)
CreateAnchor(AnchorGrid, "Move grid", tDB["unitframes"]["gridWidth"]*5+tDB["unitframes"]["gridOffset"]*4, tDB["unitframes"]["gridHeight"]*5+tDB["unitframes"]["gridOffset"]*4)

AnchorPetGrid = CreateFrame("Frame","Move_PetGrid",UIParent)
AnchorPetGrid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 15, 15)
CreateAnchor(AnchorPetGrid, "Move Pet Grid", tDB["unitframes"]["gridWidth"]*5+tDB["unitframes"]["gridOffset"]*4, tDB["unitframes"]["gridHeight"]*2+tDB["unitframes"]["gridOffset"])

if tDB["unitframes"]["hideBlizzRaid"] then
	ThunderKill(CompactRaidFrameManager)
end

local fixStatusbar = function(bar)
    bar:GetStatusBarTexture():SetHorizTile(false)
    bar:GetStatusBarTexture():SetVertTile(false)
end

-- SetPoint of MOTHERFUCKING DOOM!
local function SAP()
	local pos, posRel, spacingX, spacingY, colX, colY, growth, point
	
	if tDB["unitframes"]["gridPoint"] == "TOP" and tDB["unitframes"]["gridGrowth"] == "LEFT" then
		pos = "TOPRIGHT"
		posRel = "TOPLEFT"
		growth = "RIGHT"
		spacingX = 0
		spacingY = -(tDB["unitframes"]["gridOffset"])
		colX = -(tDB["unitframes"]["gridOffset"])
		colY = 0
		point = "TOPRIGHT"
	elseif tDB["unitframes"]["gridPoint"] == "TOP" and tDB["unitframes"]["gridGrowth"] == "RIGHT" then
		pos = "TOPLEFT"
		posRel = "TOPRIGHT"
		growth = "LEFT"
		spacingX = 0
		spacingY = -(tDB["unitframes"]["gridOffset"])
		colX = tDB["unitframes"]["gridOffset"]
		colY = 0
		point = "TOPLEFT"
	elseif tDB["unitframes"]["gridPoint"] == "LEFT" and tDB["unitframes"]["gridGrowth"] == "TOP" then
		pos = "BOTTOMLEFT"
		posRel = "TOPLEFT"
		growth = "BOTTOM"
		spacingX = tDB["unitframes"]["gridOffset"]
		spacingY = 0
		colX = 0
		colY = tDB["unitframes"]["gridOffset"]
		point = "BOTTOMLEFT"
	elseif tDB["unitframes"]["gridPoint"] == "LEFT" and tDB["unitframes"]["gridGrowth"] == "BOTTOM" then
		pos = "TOPLEFT"
		posRel = "BOTTOMLEFT"
		growth = "TOP"
		spacingX = tDB["unitframes"]["gridOffset"]
		spacingY = 0
		colX = 0
		colY = -(tDB["unitframes"]["gridOffset"])
		point = "TOPLEFT"
	elseif tDB["unitframes"]["gridPoint"] == "RIGHT" and tDB["unitframes"]["gridGrowth"] == "TOP" then
		pos = "BOTTOMRIGHT"
		posRel = "TOPRIGHT"
		growth = "BOTTOM"
		spacingX = -(tDB["unitframes"]["gridOffset"])
		spacingY = 0
		colX = 0
		colY = tDB["unitframes"]["gridOffset"]
		point = "BOTTOMRIGHT"
	elseif tDB["unitframes"]["gridPoint"] == "RIGHT" and tDB["unitframes"]["gridGrowth"] == "BOTTOM" then
		pos = "TOPRIGHT"
		posRel = "BOTTOMRIGHT"
		growth = "TOP"
		spacingX = -(tDB["unitframes"]["gridOffset"])
		spacingY = 0
		colX = 0
		colY = -(tDB["unitframes"]["gridOffset"])
		point = "TOPRIGHT"
	elseif tDB["unitframes"]["gridPoint"] == "BOTTOM" and tDB["unitframes"]["gridGrowth"] == "LEFT" then
		pos = "BOTTOMRIGHT"
		posRel = "BOTTOMLEFT"
		growth = "RIGHT"
		spacingX = 0
		spacingY = (tDB["unitframes"]["gridOffset"])
		colX = -(tDB["unitframes"]["gridOffset"])
		colY = 0
		point = "BOTTOMRIGHT"
	elseif tDB["unitframes"]["gridPoint"] == "BOTTOM" and tDB["unitframes"]["gridGrowth"] == "RIGHT" then
		pos = "BOTTOMLEFT"
		posRel = "BOTTOMRIGHT"
		growth = "LEFT"
		spacingX = 0
		spacingY = (tDB["unitframes"]["gridOffset"])
		colX = (tDB["unitframes"]["gridOffset"])
		colY = 0
		point = "BOTTOMLEFT"
	else -- You failed to equal any of the above. So I give this...
		pos = "TOPLEFT"
		posRel = "TOPRIGHT"
		growth = "LEFT"
		spacingX = 0
		spacingY = -(tDB["unitframes"]["gridOffset"])
		colX = tDB["unitframes"]["gridOffset"]
		colY = 0
		point = "TOPLEFT"
	end
	
	return pos, posRel, spacingX, spacingY, colX, colY, growth, point
end

local siValue = function(value)
    if value >= 10000000 then 
        return string.format('%.1fm', value / 1000000) 
    elseif value >= 1000000 then
        return string.format('%.2fm', value / 1000000) 
    elseif value >= 100000 then
        return string.format('%.0fk', value / 1000) 
    elseif value >= 10000 then
        return string.format('%.1fk', value / 1000) 
    else
        return value
    end
end

local dropdown = CreateFrame('Frame', name .. 'DropDown', UIParent, 'UIDropDownMenuTemplate')

function addon:menu()
	dropdown:SetParent(self)
	return ToggleDropDownMenu(1, nil, dropdown, 'cursor', 0, 0)
end

----------------------------------------------
-- Menu --
-- Slightly altered version of:
-- FrameXML/CompactUnitFrame.lua:730:CompactUnitFrameDropDown_Initialize
----------------------------------------------
local init = function(self)
	local unit = self:GetParent().unit
	local menu, name, id

	if(not unit) then
		return
	end

	if(UnitIsUnit(unit, "player")) then
		menu = "SELF"
	elseif(UnitIsUnit(unit, "vehicle")) then
		-- NOTE: vehicle check must come before pet check for accuracy's sake because
		-- a vehicle may also be considered your pet
		menu = "VEHICLE"
	elseif(UnitIsUnit(unit, "pet")) then
		menu = "PET"
	elseif(UnitIsPlayer(unit)) then
		id = UnitInRaid(unit)
		if(id) then
			menu = "RAID_PLAYER"
			name = GetRaidRosterInfo(id)
		elseif(UnitInParty(unit)) then
			menu = "PARTY"
		else
			menu = "PLAYER"
		end
	else
		menu = "TARGET"
		name = RAID_TARGET_ICON
	end

	if(menu) then
		UnitPopup_ShowMenu(self, menu, unit, name, id)
	end
end

UIDropDownMenu_Initialize(dropdown, init, 'MENU')

-----------------------------

local function freebutf8sub(str, start, numChars) 
    local currentIndex = start 
    while numChars > 0 and currentIndex <= #str do 
        local char = string.byte(str, currentIndex) 
        if char >= 240 then 
            currentIndex = currentIndex + 4 
        elseif char >= 225 then 
            currentIndex = currentIndex + 3 
        elseif char >= 192 then 
            currentIndex = currentIndex + 2 
        else 
            currentIndex = currentIndex + 1 
        end 
        numChars = numChars - 1 
    end 
    return str:sub(start, currentIndex - 1) 
end
local nameCache = {}

local PostUpdateHealth = function(health, unit, min, max)
    local name = UnitName(unit) or "Unknown"
    local self = health.__owner
    local val = 1
    if tDB["unitframes"]["gridPower"] then
        val = 8
    end

	if nameCache[name] then 
		self.Info:SetText(nameCache[name]) 
	else 
		local substring 
		for length=#name, 1, -1 do 
			substring = freebutf8sub(name, 1, length) 
			self.Info:SetText(substring) 
			if self.Info:GetStringWidth() <= tDB["unitframes"]["gridWidth"] - val then break end 
		end
		nameCache[name] = substring
	end

	local r, g, b = .84, .75, .65
	local t
	if(UnitIsPlayer(unit)) then
		local _, class = UnitClass(unit)
		t = oUF.colors.class[class]
	else		
		r, g, b = .2, .9, .1
	end

	if(t) then
		r, g, b = t[1], t[2], t[3]
	end
	
	if tDB["unitframes"]["ClassColor"] and not tDB["unitframes"]["InvertColor"] then
		self.Info:SetTextColor(1, 1, 1)
	else
		self.Info:SetTextColor(r, g, b)
	end

	if not UnitIsConnected(unit) or UnitIsDead(unit) or UnitIsGhost(unit) then
		health:SetValue(0)
			
		if not UnitIsConnected(unit) then
			health.value:SetText("|cffD7BEA5".."Offline".."|r")
		elseif UnitIsDead(unit) then
			health.value:SetText("|cffD7BEA5".."Dead".."|r")
		elseif UnitIsGhost(unit) then
			health.value:SetText("|cffD7BEA5".."Ghost".."|r")
		end
		
		if tDB["unitframes"]["ClassColor"] and (not tDB["unitframes"]["InvertColor"]) then
			local class = select(2, UnitClass(unit))
			local color = UnitIsPlayer(unit) and oUF.colors.class[class] or {0.84, 0.75, 0.65}
			health.bg:SetVertexColor(color[1]*tDB["unitframes"]["uicontrast"], color[2]*tDB["unitframes"]["uicontrast"], color[3]*tDB["unitframes"]["uicontrast"])
		elseif tDB["unitframes"]["ClassColor"] and tDB["unitframes"]["InvertColor"] then
			local class = select(2, UnitClass(unit))
			local color = UnitIsPlayer(unit) and oUF.colors.class[class] or {0.84, 0.75, 0.65}		
			health.bg:SetVertexColor(color[1], color[2], color[3])
		else
			health.bg:SetVertexColor(0, 0, 0)
		end
	else
		if tDB["unitframes"]["ClassColor"] then
			local r, g, b = .84, .75, .65
			local t
			local reaction = UnitReaction(unit, "player")
			if(UnitIsPlayer(unit)) then
				local _, class = UnitClass(unit)
				t = oUF.colors.class[class]
			elseif reaction then
				t = oUF.colors.reaction[reaction]
			else
				r, g, b = .2, .9, .1
			end

			if(t) then
				r, g, b = t[1], t[2], t[3]
			end

			if tDB["unitframes"]["InvertColor"] then
				health:SetStatusBarColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
				health.bg:SetVertexColor(r, g, b)			
			else
				health:SetStatusBarColor(r, g, b)
				health.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
			end
		else
			local r, g, b
			r, g, b = oUF.ColorGradient(min/max, 0.69, 0.21, 0.21, 0.51, 0.23, 0.14, 0.1, 0.15, 0.1)

			health:SetStatusBarColor(r, g, b)
			health.bg:SetVertexColor(0, 0, 0)
		end
		health.value:SetText("")
	end
end

local PostUpdatePower = function(power, unit, min, max)
	local _, ptype = UnitPowerType(unit)
	local self = power:GetParent()

	if ptype == 'MANA' then
		if(tDB["unitframes"]["gridOrient"] == "VERTICAL")then
			power:SetPoint("TOP", 0, -1)
			power:SetWidth(tDB["unitframes"]["gridWidth"]*tDB["unitframes"]["gridPowerSize"])
			self.Health:SetWidth((1 - tDB["unitframes"]["gridPowerSize"])*tDB["unitframes"]["gridWidth"]-2)
		else
			power:SetPoint("LEFT", 1, 0)
			power:SetHeight(tDB["unitframes"]["gridHeight"]*tDB["unitframes"]["gridPowerSize"])
			self.Health:SetHeight((1 - tDB["unitframes"]["gridPowerSize"])*tDB["unitframes"]["gridHeight"]-2)
		end
	else
		if(tDB["unitframes"]["gridOrient"] == "VERTICAL")then
			power:SetPoint("TOP", 0, -1)
			power:SetWidth(0.0000001) -- in this case absolute zero is something, rather than nothing
			self.Health:SetWidth(tDB["unitframes"]["gridWidth"]-2)
		else
			power:SetPoint("LEFT", 1, 0)
			power:SetHeight(0.0000001) -- ^ ditto
			self.Health:SetHeight(tDB["unitframes"]["gridHeight"]-2)
		end
	end
	
	if tDB["unitframes"]["ClassColor"] then
		local r, g, b = 1, 1, 1
			if(oUF.colors.power[ptype]) then
				r, g, b = unpack(thundercolors.power[ptype])
			end
		
		if tDB["unitframes"]["InvertColor"] then
			power:SetStatusBarColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
			power.bg:SetVertexColor(r, g, b)
		else
			power:SetStatusBarColor(r, g, b)
			power.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
		end
	else
		local r, g, b = .84, .75, .65
		local t
		local reaction = UnitReaction(unit, "player")
		if(UnitIsPlayer(unit)) then
			local _, class = UnitClass(unit)
			t = oUF.colors.class[class]
		elseif reaction then
			t = oUF.colors.reaction[reaction]
		else
			r, g, b = .1, .8, .3
		end

		if(t) then
			r, g, b = t[1], t[2], t[3]
		end
		power:SetStatusBarColor(r, g, b)
		power.bg:SetVertexColor(r*tDB["unitframes"]["uicontrast"], g*tDB["unitframes"]["uicontrast"], b*tDB["unitframes"]["uicontrast"])
	end
end

local updateThreat = function(self, event, unit)
	if(unit ~= self.unit) then return end
	local threat = self.Threat

	unit = unit or self.unit
	local status = UnitThreatSituation(unit)

	if(status and status > 1) then
		local r, g, b = GetThreatStatusColor(status)
		threat:SetBackdropBorderColor(r, g, b, 1)
	else
		threat:SetBackdropBorderColor(unpack(tDB["cfgMedia"]["colorBR"]))
		threat:SetAlpha(1)
	end
	threat:Show()
end

local _, class = UnitClass("player")
local dispellClass = {
    PRIEST = {
		Magic = true,
		Disease = true,
	},
    SHAMAN = {
		Curse = true,
	},
    PALADIN = {
		Poison = true,
		Disease = true,
	},
    MAGE = {
		Curse = true,
	},
    DRUID = {
		Curse = true,
		Poison = true,
	},
}
 -- talentchecker, thx for original idea Heckffy
local TalentChecker = CreateFrame("Frame");
TalentChecker:RegisterEvent("PLAYER_ENTERING_WORLD");
TalentChecker:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
TalentChecker:RegisterEvent("CHARACTER_POINTS_CHANGED");
TalentChecker:SetScript("OnEvent", function()
	dispellClass.SHAMAN.Magic = (select(5, GetTalentInfo(3, 12, false, false, nil)) == 1);
	dispellClass.PALADIN.Magic = (select(5, GetTalentInfo(1, 14, false, false, nil)) == 1);
	dispellClass.DRUID.Magic = (select(5, GetTalentInfo(3, 17, false, false, nil)) == 1);
end);

local dispellist = dispellClass[class] or {}
local dispellPriority = {
    Magic = 4,
    Poison = 3,
    Curse = 2,
    Disease = 1,
}

local instDebuffs = {}
local instances = addon.auras.instances
local getzone = function()
    local zone = GetInstanceInfo()
    if instances[zone] then
        instDebuffs = instances[zone]
    else
        instDebuffs = {}
    end
end

local debuffs, buffs = addon.auras.debuffs, addon.auras.buffs 
local CustomFilter = function(icons, ...)
    local _, icon, name, _, _, _, dtype = ...

    if instDebuffs[name] then
        icon.priority = instDebuffs[name]
        return true
    elseif debuffs[name] then
        icon.priority = debuffs[name]
        return true
    elseif buffs[name] then
        icon.priority = buffs[name]
        icon.buff = true
        return true
    elseif dispellist[dtype] then
        icon.priority = dispellPriority[dtype]
        icon.buff = false
        return true
    else
        icon.priority = 0
    end
end

-- Show Mouseover highlight
local OnEnter = function(self)
    UnitFrame_OnEnter(self)
	self.Highlight:Show()	
end

local OnLeave = function(self)
    UnitFrame_OnLeave(self)
	self.Highlight:Hide()	
end

local sharedstyle = function(self)
    self.menu = addon.menu

	self:SetScript("OnEnter", OnEnter)
    self:SetScript("OnLeave", OnLeave)
	self:RegisterForClicks("LeftButtonDown", "RightButtonDown")
	self:SetAttribute("*type2", "menu")

----------------------------------------------
-- Фон
----------------------------------------------

	threat = CreateFrame("Frame", nil, self)
	threat:SetAllPoints()
	SetTemplate(threat, "bushadow")
	threat.Override = updateThreat
	self.Threat = threat
	
----------------------------------------------
-- Тень
----------------------------------------------
	

----------------------------------------------
-- Хп бар
----------------------------------------------

	self.Health = CreateFrame("StatusBar", nil, self)
	self.Health:SetOrientation(tDB["unitframes"]["gridOrient"])
	self.Health:SetPoint("TOP", 0, -1)
	self.Health:SetPoint("LEFT", 1, 0)
	if tDB["unitframes"]["gridOrient"] == "VERTICAL" then
		self.Health:SetPoint("BOTTOM", 0, 1)
	else
		self.Health:SetPoint("RIGHT", -1, 0)
	end
	self.Health:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
	fixStatusbar(self.Health)
	self.Health.frequentUpdates = true
	self.Health.Smooth = true

	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints()
	self.Health.bg:SetTexture(tDB["cfgMedia"]["textureBar"])

	self.Health.PostUpdate = PostUpdateHealth

	self.Health.value = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.value:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["fontsize"]-1)
	self.Health.value:SetJustifyH("RIGHT")
	self.Health.value:SetShadowColor(0, 0, 0)
	self.Health.value:SetShadowOffset(1, -1)
	self.Health.value:SetTextColor(1, 1, 1)
	self.Health.value:SetPoint("TOPRIGHT", -1, -1)
	
----------------------------------------------
-- Манабары?
----------------------------------------------

if tDB["unitframes"]["gridPower"] then
	self.Power = CreateFrame("StatusBar", nil, self)
    self.Power:SetOrientation(tDB["unitframes"]["gridOrient"])
	self.Power:SetPoint("BOTTOM", self, 0, 1)
    self.Power:SetPoint("RIGHT", self, -1, 0)
	self.Power:SetStatusBarTexture(tDB["cfgMedia"]["textureBar"])
    fixStatusbar(self.Power)
    
    self.Power.frequentUpdates = true
	self.Power.Smooth = true

    self.Power.bg = self.Power:CreateTexture(nil, "BORDER")
    self.Power.bg:SetAllPoints(self.Power)
    self.Power.bg:SetTexture(tDB["cfgMedia"]["textureBar"])

    self.Power.PostUpdate = PostUpdatePower
end

----------------------------------------------
-- Подсветка
----------------------------------------------

    self.Highlight = self.Health:CreateTexture(nil, "OVERLAY")
    self.Highlight:SetAllPoints()
    self.Highlight:SetTexture(tDB["cfgMedia"]["textureBlank"])
    self.Highlight:SetVertexColor(1,1,1,.1)
    self.Highlight:SetBlendMode("ADD")
    self.Highlight:Hide()

----------------------------------------------
-- Raid Icons
----------------------------------------------

    self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
    self.RaidIcon:SetPoint("TOP", self, 0, 4)
    self.RaidIcon:SetSize(tDB["unitframes"]["gridIconSize"], tDB["unitframes"]["gridIconSize"])

----------------------------------------------
-- Leader Icon
----------------------------------------------

    self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
    self.Leader:SetPoint("TOPLEFT", self, 0, 8)
    self.Leader:SetSize(tDB["unitframes"]["gridIconSize"], tDB["unitframes"]["gridIconSize"])

----------------------------------------------
-- Assistant Icon
----------------------------------------------

    self.Assistant = self.Health:CreateTexture(nil, "OVERLAY")
    self.Assistant:SetPoint("TOPLEFT", self, 0, 8)
    self.Assistant:SetSize(tDB["unitframes"]["gridIconSize"], tDB["unitframes"]["gridIconSize"])

----------------------------------------------
-- Raid Icons
----------------------------------------------    

	self.MasterLooter = self.Health:CreateTexture(nil, 'OVERLAY')
    self.MasterLooter:SetSize(tDB["unitframes"]["gridIconSize"], tDB["unitframes"]["gridIconSize"])
    self.MasterLooter:SetPoint('LEFT', self.Leader, 'RIGHT')

----------------------------------------------
-- Ready Check
----------------------------------------------

	self.ReadyCheck = self.Health:CreateTexture(nil, "OVERLAY")
    self.ReadyCheck:SetPoint("TOP", self)
    self.ReadyCheck:SetSize(tDB["unitframes"]["gridIconSize"], tDB["unitframes"]["gridIconSize"])	
	
----------------------------------------------
-- Имя
----------------------------------------------
	
    self.Info = self.Health:CreateFontString(nil, "OVERLAY")
    self.Info:SetPoint("TOP", 0, -7)
    self.Info:SetJustifyH("CENTER")
    self.Info:SetFont(tDB["unitframes"]["font"], tDB["unitframes"]["fontsize"])
    self.Info:SetShadowOffset(1.25, -1.25)

----------------------------------------------
-- Enable Indicators
----------------------------------------------
 
    self.freebIndicators = true	
	
----------------------------------------------
-- Дальность
----------------------------------------------

	self.Range = {
		insideAlpha = 1,
		outsideAlpha = 0.5
	}

----------------------------------------------
-- AURAS!
----------------------------------------------

    local auras = CreateFrame("Frame", nil, self)
    auras:SetSize(tDB["unitframes"]["gridAuraSize"], tDB["unitframes"]["gridAuraSize"])
    auras:SetPoint("BOTTOMLEFT", self.Health, 1, 1)
    auras.size = tDB["unitframes"]["gridAuraSize"]
    auras.CustomFilter = CustomFilter
    self.freebAuras = auras

	self:RegisterEvent('PLAYER_ENTERING_WORLD', getzone)
end

oUF:RegisterStyle("Freebgrid", sharedstyle)

oUF:Factory(function(self)
    self:SetActiveStyle"Freebgrid"

	local pos, posRel, spacingX, spacingY, colX, colY, growth, point = SAP()

	raid = {}
	for i = 1, tDB["unitframes"]["gridParty"] do 
		local group = self:SpawnHeader('Raid_Freebgrid'..i, nil, 'raid,party,solo',
		'oUF-initialConfigFunction', ([[
			self:SetWidth(%d)
			self:SetHeight(%d)
			]]):format(tDB["unitframes"]["gridWidth"], tDB["unitframes"]["gridHeight"]),
		'showPlayer', true,
		'showSolo', false,
		'showParty', true,
		'showRaid', true,
		'xoffset', spacingX, 
		'yOffset', spacingY,
		'point', tDB["unitframes"]["gridPoint"],
		'groupFilter', tostring(i),
		'groupingOrder', '1,2,3,4,5,6,7,8',
		'groupBy', 'GROUP',
		'maxColumns', tDB["unitframes"]["gridParty"],
		'unitsPerColumn', 5,
		'columnSpacing', tDB["unitframes"]["gridOffset"],
		'columnAnchorPoint', growth
		)
		if i == 1 then
			group:SetPoint(point, AnchorGrid, point)
		else
			group:SetPoint(pos, raid[i-1], posRel, colX, colY)
		end
		group:SetScale(1)
		raid[i] = group
	end
		
	if tDB["unitframes"]["gridPets"] then
        local pets = self:SpawnHeader('Pet_Freebgrid', 'SecureGroupPetHeaderTemplate', 'raid,party,solo',
        'oUF-initialConfigFunction', ([[
			self:SetWidth(%d)
			self:SetHeight(%d)
			self:SetAttribute('unitsuffix', 'pet')
			]]):format(tDB["unitframes"]["gridWidth"], tDB["unitframes"]["gridHeight"]),
        'showSolo', false,
        'showParty', true,
        'showRaid', true,
        'xoffset', spacingX,
        'yOffset', spacingY,
        'point', tDB["unitframes"]["gridPoint"],
        'maxColumns', 2,
        'unitsPerColumn', 5,
        'columnSpacing', tDB["unitframes"]["gridOffset"],
        'columnAnchorPoint', growth,
		'useOwnerUnit', true
        )
        pets:SetPoint(point, AnchorPetGrid, point, 0, 0)
        pets:SetScale(1)
    end

    if tDB["unitframes"]["gridMT"] then
        local tank = self:SpawnHeader('MT_Freebgrid', nil, 'raid,party,solo',
        'oUF-initialConfigFunction', ([[
            self:SetWidth(%d)
            self:SetHeight(%d)
            ]]):format(tDB["unitframes"]["gridWidth"], tDB["unitframes"]["gridHeight"]),
        "showRaid", true,
        "yOffset", -tDB["unitframes"]["gridOffset"]
        )
        tank:SetPoint(point, raidmtframe, point, 0, 0)

        if oRA3 then
            tank:SetAttribute("initial-unitWatch", true)
            tank:SetAttribute("nameList", table.concat(oRA3:GetSortedTanks(), ","))

            local tankhandler = {}
            function tankhandler:OnTanksUpdated(event, tanks) 
                tank:SetAttribute("nameList", table.concat(tanks, ","))
            end
            oRA3.RegisterCallback(tankhandler, "OnTanksUpdated")

        else
            tank:SetAttribute('groupFilter', 'MAINTANK')
        end
        tank:SetScale(1)
    end
end)